/*
 * Configuracion_Mota.c
 *
 *  Created on: 04/06/2014
 *      Author: Luis J. Lpez
*/

/*
 * Defines.h
 *
 *  Created on: 25/03/2014
 *      Author: Usuario
 */
/* ============================================================================ */
/* Copyright (c) 2016, Texas Instruments Incorporated                           */
/*  All rights reserved.                                                        */
/*                                                                              */
/*  Redistribution and use in source and binary forms, with or without          */
/*  modification, are permitted provided that the following conditions          */
/*  are met:                                                                    */
/*                                                                              */
/*  *  Redistributions of source code must retain the above copyright           */
/*     notice, this list of conditions and the following disclaimer.            */
/*                                                                              */
/*  *  Redistributions in binary form must reproduce the above copyright        */
/*     notice, this list of conditions and the following disclaimer in the      */
/*     documentation and/or other materials provided with the distribution.     */
/*                                                                              */
/*  *  Neither the name of Texas Instruments Incorporated nor the names of      */
/*     its contributors may be used to endorse or promote products derived      */
/*     from this software without specific prior written permission.            */
/*                                                                              */
/*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" */
/*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,       */
/*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR      */
/*  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/*  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       */
/*  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         */
/*  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; */
/*  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    */
/*  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     */
/*  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,              */
/*  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                          */
/* ============================================================================ */

/********************************************************************
*
* Standard register and bit definitions for the Texas Instruments
* MSP430 microcontroller.
*
* This file supports assembler and C development for
* MSP430F5232 devices.
*
* Texas Instruments, Version 1.1
*
* Rev. 1.0, Setup
* Rev. 1.1  Changed access type of TimerA/B registers to word only
*
********************************************************************/






/*----------------------------------------------------------------------------*/
/* PERIPHERAL FILE MAP                                                        */
/*----------------------------------------------------------------------------*/

/* External references resolved by a device-specific linker command file */
//#define SFR_20BIT(address)  extern volatile unsigned int address
typedef void (* __SFR_FARPTR)();



/************************************************************
* STANDARD BITS
************************************************************/


/************************************************************
* STATUS REGISTER BITS
************************************************************/


/* Low Power Modes coded with Bits 4-7 in SR */


/* ============================================================================ */
/* Copyright (c) 2013, Texas Instruments Incorporated                           */
/*  All rights reserved.                                                        */
/*                                                                              */
/*  Redistribution and use in source and binary forms, with or without          */
/*  modification, are permitted provided that the following conditions          */
/*  are met:                                                                    */
/*                                                                              */
/*  *  Redistributions of source code must retain the above copyright           */
/*     notice, this list of conditions and the following disclaimer.            */
/*                                                                              */
/*  *  Redistributions in binary form must reproduce the above copyright        */
/*     notice, this list of conditions and the following disclaimer in the      */
/*     documentation and/or other materials provided with the distribution.     */
/*                                                                              */
/*  *  Neither the name of Texas Instruments Incorporated nor the names of      */
/*     its contributors may be used to endorse or promote products derived      */
/*     from this software without specific prior written permission.            */
/*                                                                              */
/*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" */
/*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,       */
/*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR      */
/*  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/*  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,       */
/*  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,         */
/*  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; */
/*  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,    */
/*  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR     */
/*  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,              */
/*  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                          */
/* ============================================================================ */

/*----------------------------------------------------------------------------*/
/* INTRINSIC MAPPING FOR IAR V1.XX                                            */
/*----------------------------------------------------------------------------*/


/*****************************************************************************/
/*  INTRINSICS.H                                                             */
/*                                                                           */
/* Copyright (c) 2005 Texas Instruments Incorporated                         */
/* http://www.ti.com/                                                        */
/*                                                                           */
/*  Redistribution and  use in source  and binary forms, with  or without    */
/*  modification,  are permitted provided  that the  following conditions    */
/*  are met:                                                                 */
/*                                                                           */
/*     Redistributions  of source  code must  retain the  above copyright    */
/*     notice, this list of conditions and the following disclaimer.         */
/*                                                                           */
/*     Redistributions in binary form  must reproduce the above copyright    */
/*     notice, this  list of conditions  and the following  disclaimer in    */
/*     the  documentation  and/or   other  materials  provided  with  the    */
/*     distribution.                                                         */
/*                                                                           */
/*     Neither the  name of Texas Instruments Incorporated  nor the names    */
/*     of its  contributors may  be used to  endorse or  promote products    */
/*     derived  from   this  software  without   specific  prior  written    */
/*     permission.                                                           */
/*                                                                           */
/*  THIS SOFTWARE  IS PROVIDED BY THE COPYRIGHT  HOLDERS AND CONTRIBUTORS    */
/*  "AS IS"  AND ANY  EXPRESS OR IMPLIED  WARRANTIES, INCLUDING,  BUT NOT    */
/*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    */
/*  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT    */
/*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/*  SPECIAL,  EXEMPLARY,  OR CONSEQUENTIAL  DAMAGES  (INCLUDING, BUT  NOT    */
/*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,    */
/*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY    */
/*  THEORY OF  LIABILITY, WHETHER IN CONTRACT, STRICT  LIABILITY, OR TORT    */
/*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE    */
/*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.     */
/*                                                                           */
/*****************************************************************************/


/*---------------------------------------------------------------------------*/
/* Handle legacy conflicts                                                   */
/*---------------------------------------------------------------------------*/
/*****************************************************************************/
/*  INTRINSICS_LEGACY_UNDEFS.H                                               */
/*                                                                           */
/* Copyright (c) 2005 Texas Instruments Incorporated                         */
/* http://www.ti.com/                                                        */
/*                                                                           */
/*  Redistribution and  use in source  and binary forms, with  or without    */
/*  modification,  are permitted provided  that the  following conditions    */
/*  are met:                                                                 */
/*                                                                           */
/*     Redistributions  of source  code must  retain the  above copyright    */
/*     notice, this list of conditions and the following disclaimer.         */
/*                                                                           */
/*     Redistributions in binary form  must reproduce the above copyright    */
/*     notice, this  list of conditions  and the following  disclaimer in    */
/*     the  documentation  and/or   other  materials  provided  with  the    */
/*     distribution.                                                         */
/*                                                                           */
/*     Neither the  name of Texas Instruments Incorporated  nor the names    */
/*     of its  contributors may  be used to  endorse or  promote products    */
/*     derived  from   this  software  without   specific  prior  written    */
/*     permission.                                                           */
/*                                                                           */
/*  THIS SOFTWARE  IS PROVIDED BY THE COPYRIGHT  HOLDERS AND CONTRIBUTORS    */
/*  "AS IS"  AND ANY  EXPRESS OR IMPLIED  WARRANTIES, INCLUDING,  BUT NOT    */
/*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    */
/*  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT    */
/*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/*  SPECIAL,  EXEMPLARY,  OR CONSEQUENTIAL  DAMAGES  (INCLUDING, BUT  NOT    */
/*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,    */
/*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY    */
/*  THEORY OF  LIABILITY, WHETHER IN CONTRACT, STRICT  LIABILITY, OR TORT    */
/*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE    */
/*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.     */
/*                                                                           */
/*****************************************************************************/


/*---------------------------------------------------------------------------*/
/* Handle in430.h conflicts with legacy intrinsic names                      */
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/* General MSP Intrinsics                                                    */
/*---------------------------------------------------------------------------*/
void           __no_operation(void);

unsigned short __bic_SR_register         (unsigned short mask);
unsigned short __bic_SR_register_on_exit (unsigned short mask);
unsigned short __bis_SR_register         (unsigned short mask);
unsigned short __bis_SR_register_on_exit (unsigned short mask);
unsigned short __get_SR_register         (void);
unsigned short __get_SR_register_on_exit (void);

unsigned short __get_SP_register(void);
void           __set_SP_register(unsigned short value);

void           __delay_cycles(unsigned long cycles);

unsigned int   __even_in_range(unsigned int val, unsigned int range);

void           __op_code(unsigned short op);

/*---------------------------------------------------------------------------*/
/* General MSP Macros                                                        */
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* MSP430/430X Intrinsics                                                    */
/*---------------------------------------------------------------------------*/
void             __disable_interrupt(void);
void             __enable_interrupt(void);
void             __set_interrupt_state(unsigned short state);

unsigned short   __get_R4_register(void);
void             __set_R4_register(unsigned short value);
unsigned short   __get_R5_register(void);
void             __set_R5_register(unsigned short value);

unsigned short   __bcd_add_short(unsigned short, unsigned short);
unsigned long    __bcd_add_long(unsigned long, unsigned long);

/*---------------------------------------------------------------------------*/
/* MSP430/430X Macros                                                        */
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/* MSP430X Intrinsics                                                        */
/*---------------------------------------------------------------------------*/
void           __data16_write_addr(unsigned short, unsigned long);
unsigned long  __data16_read_addr(unsigned short);
void           __data20_write_char(unsigned long, unsigned char);
void           __data20_write_short(unsigned long, unsigned short);
void           __data20_write_long(unsigned long, unsigned long);
unsigned char  __data20_read_char(unsigned long);
unsigned short __data20_read_short(unsigned long);
unsigned long  __data20_read_long(unsigned long);


/*---------------------------------------------------------------------------*/
/* Legacy Macros                                                             */
/*---------------------------------------------------------------------------*/




/************************************************************
* PERIPHERAL FILE MAP
************************************************************/

/************************************************************
* Comparator B
************************************************************/

extern volatile unsigned int CBCTL0;                            /* Comparator B Control Register 0 */
extern volatile unsigned char CBCTL0_L;                           /* Comparator B Control Register 0 */
extern volatile unsigned char CBCTL0_H;                           /* Comparator B Control Register 0 */
extern volatile unsigned int CBCTL1;                            /* Comparator B Control Register 1 */
extern volatile unsigned char CBCTL1_L;                           /* Comparator B Control Register 1 */
extern volatile unsigned char CBCTL1_H;                           /* Comparator B Control Register 1 */
extern volatile unsigned int CBCTL2;                            /* Comparator B Control Register 2 */
extern volatile unsigned char CBCTL2_L;                           /* Comparator B Control Register 2 */
extern volatile unsigned char CBCTL2_H;                           /* Comparator B Control Register 2 */
extern volatile unsigned int CBCTL3;                            /* Comparator B Control Register 3 */
extern volatile unsigned char CBCTL3_L;                           /* Comparator B Control Register 3 */
extern volatile unsigned char CBCTL3_H;                           /* Comparator B Control Register 3 */
extern volatile unsigned int CBINT;                             /* Comparator B Interrupt Register */
extern volatile unsigned char CBINT_L;                            /* Comparator B Interrupt Register */
extern volatile unsigned char CBINT_H;                            /* Comparator B Interrupt Register */
extern volatile unsigned int CBIV;                              /* Comparator B Interrupt Vector Word */

/* CBCTL0 Control Bits */
//#define RESERVED            (0x0010)  /* Comp. B */
//#define RESERVED            (0x0020)  /* Comp. B */
//#define RESERVED            (0x0040)  /* Comp. B */
//#define RESERVED            (0x1000)  /* Comp. B */
//#define RESERVED            (0x2000)  /* Comp. B */
//#define RESERVED            (0x4000)  /* Comp. B */

/* CBCTL0 Control Bits */
//#define RESERVED            (0x0010)  /* Comp. B */
//#define RESERVED            (0x0020)  /* Comp. B */
//#define RESERVED            (0x0040)  /* Comp. B */
//#define RESERVED            (0x1000)  /* Comp. B */
//#define RESERVED            (0x2000)  /* Comp. B */
//#define RESERVED            (0x4000)  /* Comp. B */

/* CBCTL0 Control Bits */
//#define RESERVED            (0x0010)  /* Comp. B */
//#define RESERVED            (0x0020)  /* Comp. B */
//#define RESERVED            (0x0040)  /* Comp. B */
//#define RESERVED            (0x1000)  /* Comp. B */
//#define RESERVED            (0x2000)  /* Comp. B */
//#define RESERVED            (0x4000)  /* Comp. B */



/* CBCTL1 Control Bits */
//#define RESERVED            (0x2000)  /* Comp. B */
//#define RESERVED            (0x4000)  /* Comp. B */
//#define RESERVED            (0x8000)  /* Comp. B */

/* CBCTL1 Control Bits */
//#define RESERVED            (0x2000)  /* Comp. B */
//#define RESERVED            (0x4000)  /* Comp. B */
//#define RESERVED            (0x8000)  /* Comp. B */

/* CBCTL1 Control Bits */
//#define RESERVED            (0x2000)  /* Comp. B */
//#define RESERVED            (0x4000)  /* Comp. B */
//#define RESERVED            (0x8000)  /* Comp. B */



/* CBCTL2 Control Bits */

/* CBCTL2 Control Bits */

/* CBCTL2 Control Bits */








/* CBINT Control Bits */
//#define RESERVED             (0x0004)  /* Comp. B */
//#define RESERVED             (0x0008)  /* Comp. B */
//#define RESERVED             (0x0010)  /* Comp. B */
//#define RESERVED             (0x0020)  /* Comp. B */
//#define RESERVED             (0x0040)  /* Comp. B */
//#define RESERVED             (0x0080)  /* Comp. B */
//#define RESERVED             (0x0400)  /* Comp. B */
//#define RESERVED             (0x0800)  /* Comp. B */
//#define RESERVED             (0x1000)  /* Comp. B */
//#define RESERVED             (0x2000)  /* Comp. B */
//#define RESERVED             (0x4000)  /* Comp. B */
//#define RESERVED             (0x8000)  /* Comp. B */

/* CBINT Control Bits */
//#define RESERVED             (0x0004)  /* Comp. B */
//#define RESERVED             (0x0008)  /* Comp. B */
//#define RESERVED             (0x0010)  /* Comp. B */
//#define RESERVED             (0x0020)  /* Comp. B */
//#define RESERVED             (0x0040)  /* Comp. B */
//#define RESERVED             (0x0080)  /* Comp. B */
//#define RESERVED             (0x0400)  /* Comp. B */
//#define RESERVED             (0x0800)  /* Comp. B */
//#define RESERVED             (0x1000)  /* Comp. B */
//#define RESERVED             (0x2000)  /* Comp. B */
//#define RESERVED             (0x4000)  /* Comp. B */
//#define RESERVED             (0x8000)  /* Comp. B */

/* CBINT Control Bits */
//#define RESERVED             (0x0004)  /* Comp. B */
//#define RESERVED             (0x0008)  /* Comp. B */
//#define RESERVED             (0x0010)  /* Comp. B */
//#define RESERVED             (0x0020)  /* Comp. B */
//#define RESERVED             (0x0040)  /* Comp. B */
//#define RESERVED             (0x0080)  /* Comp. B */
//#define RESERVED             (0x0400)  /* Comp. B */
//#define RESERVED             (0x0800)  /* Comp. B */
//#define RESERVED             (0x1000)  /* Comp. B */
//#define RESERVED             (0x2000)  /* Comp. B */
//#define RESERVED             (0x4000)  /* Comp. B */
//#define RESERVED             (0x8000)  /* Comp. B */

/* CBIV Definitions */

/*************************************************************
* CRC Module
*************************************************************/

extern volatile unsigned int CRCDI;                             /* CRC Data In Register */
extern volatile unsigned char CRCDI_L;                            /* CRC Data In Register */
extern volatile unsigned char CRCDI_H;                            /* CRC Data In Register */
extern volatile unsigned int CRCDIRB;                           /* CRC data in reverse byte Register */
extern volatile unsigned char CRCDIRB_L;                          /* CRC data in reverse byte Register */
extern volatile unsigned char CRCDIRB_H;                          /* CRC data in reverse byte Register */
extern volatile unsigned int CRCINIRES;                         /* CRC Initialisation Register and Result Register */
extern volatile unsigned char CRCINIRES_L;                        /* CRC Initialisation Register and Result Register */
extern volatile unsigned char CRCINIRES_H;                        /* CRC Initialisation Register and Result Register */
extern volatile unsigned int CRCRESR;                           /* CRC reverse result Register */
extern volatile unsigned char CRCRESR_L;                          /* CRC reverse result Register */
extern volatile unsigned char CRCRESR_H;                          /* CRC reverse result Register */

/************************************************************
* DMA_X
************************************************************/

extern volatile unsigned int DMACTL0;                           /* DMA Module Control 0 */
extern volatile unsigned char DMACTL0_L;                          /* DMA Module Control 0 */
extern volatile unsigned char DMACTL0_H;                          /* DMA Module Control 0 */
extern volatile unsigned int DMACTL1;                           /* DMA Module Control 1 */
extern volatile unsigned char DMACTL1_L;                          /* DMA Module Control 1 */
extern volatile unsigned char DMACTL1_H;                          /* DMA Module Control 1 */
extern volatile unsigned int DMACTL2;                           /* DMA Module Control 2 */
extern volatile unsigned char DMACTL2_L;                          /* DMA Module Control 2 */
extern volatile unsigned char DMACTL2_H;                          /* DMA Module Control 2 */
extern volatile unsigned int DMACTL3;                           /* DMA Module Control 3 */
extern volatile unsigned char DMACTL3_L;                          /* DMA Module Control 3 */
extern volatile unsigned char DMACTL3_H;                          /* DMA Module Control 3 */
extern volatile unsigned int DMACTL4;                           /* DMA Module Control 4 */
extern volatile unsigned char DMACTL4_L;                          /* DMA Module Control 4 */
extern volatile unsigned char DMACTL4_H;                          /* DMA Module Control 4 */
extern volatile unsigned int DMAIV;                             /* DMA Interrupt Vector Word */
extern volatile unsigned char DMAIV_L;                            /* DMA Interrupt Vector Word */
extern volatile unsigned char DMAIV_H;                            /* DMA Interrupt Vector Word */

extern volatile unsigned int DMA0CTL;                           /* DMA Channel 0 Control */
extern volatile unsigned char DMA0CTL_L;                          /* DMA Channel 0 Control */
extern volatile unsigned char DMA0CTL_H;                          /* DMA Channel 0 Control */
extern __SFR_FARPTR DMA0SA;                            /* DMA Channel 0 Source Address */
extern volatile unsigned int DMA0SAL;                           /* DMA Channel 0 Source Address */
extern volatile unsigned int DMA0SAH;                           /* DMA Channel 0 Source Address */
extern __SFR_FARPTR DMA0DA;                            /* DMA Channel 0 Destination Address */
extern volatile unsigned int DMA0DAL;                           /* DMA Channel 0 Destination Address */
extern volatile unsigned int DMA0DAH;                           /* DMA Channel 0 Destination Address */
extern volatile unsigned int DMA0SZ;                            /* DMA Channel 0 Transfer Size */

extern volatile unsigned int DMA1CTL;                           /* DMA Channel 1 Control */
extern volatile unsigned char DMA1CTL_L;                          /* DMA Channel 1 Control */
extern volatile unsigned char DMA1CTL_H;                          /* DMA Channel 1 Control */
extern __SFR_FARPTR DMA1SA;                            /* DMA Channel 1 Source Address */
extern volatile unsigned int DMA1SAL;                           /* DMA Channel 1 Source Address */
extern volatile unsigned int DMA1SAH;                           /* DMA Channel 1 Source Address */
extern __SFR_FARPTR DMA1DA;                            /* DMA Channel 1 Destination Address */
extern volatile unsigned int DMA1DAL;                           /* DMA Channel 1 Destination Address */
extern volatile unsigned int DMA1DAH;                           /* DMA Channel 1 Destination Address */
extern volatile unsigned int DMA1SZ;                            /* DMA Channel 1 Transfer Size */

extern volatile unsigned int DMA2CTL;                           /* DMA Channel 2 Control */
extern volatile unsigned char DMA2CTL_L;                          /* DMA Channel 2 Control */
extern volatile unsigned char DMA2CTL_H;                          /* DMA Channel 2 Control */
extern __SFR_FARPTR DMA2SA;                            /* DMA Channel 2 Source Address */
extern volatile unsigned int DMA2SAL;                           /* DMA Channel 2 Source Address */
extern volatile unsigned int DMA2SAH;                           /* DMA Channel 2 Source Address */
extern __SFR_FARPTR DMA2DA;                            /* DMA Channel 2 Destination Address */
extern volatile unsigned int DMA2DAL;                           /* DMA Channel 2 Destination Address */
extern volatile unsigned int DMA2DAH;                           /* DMA Channel 2 Destination Address */
extern volatile unsigned int DMA2SZ;                            /* DMA Channel 2 Transfer Size */

/* DMACTL0 Control Bits */

/* DMACTL0 Control Bits */

/* DMACTL0 Control Bits */

/* DMACTL01 Control Bits */

/* DMACTL01 Control Bits */

/* DMACTL4 Control Bits */

/* DMACTL4 Control Bits */

/* DMAxCTL Control Bits */

/* DMAxCTL Control Bits */

/* DMAxCTL Control Bits */





/* DMAIV Definitions */







/*************************************************************
* Flash Memory
*************************************************************/

extern volatile unsigned int FCTL1;                             /* FLASH Control 1 */
extern volatile unsigned char FCTL1_L;                            /* FLASH Control 1 */
extern volatile unsigned char FCTL1_H;                            /* FLASH Control 1 */
//sfrbw    FCTL2                  (0x0142)  /* FLASH Control 2 */
extern volatile unsigned int FCTL3;                             /* FLASH Control 3 */
extern volatile unsigned char FCTL3_L;                            /* FLASH Control 3 */
extern volatile unsigned char FCTL3_H;                            /* FLASH Control 3 */
extern volatile unsigned int FCTL4;                             /* FLASH Control 4 */
extern volatile unsigned char FCTL4_L;                            /* FLASH Control 4 */
extern volatile unsigned char FCTL4_H;                            /* FLASH Control 4 */


/* FCTL1 Control Bits */
//#define RESERVED            (0x0001)  /* Reserved */
//#define RESERVED            (0x0008)  /* Reserved */
//#define RESERVED            (0x0010)  /* Reserved */

/* FCTL1 Control Bits */
//#define RESERVED            (0x0001)  /* Reserved */
//#define RESERVED            (0x0008)  /* Reserved */
//#define RESERVED            (0x0010)  /* Reserved */

/* FCTL3 Control Bits */
//#define RESERVED            (0x0080)  /* Reserved */

/* FCTL3 Control Bits */
//#define RESERVED            (0x0080)  /* Reserved */

/* FCTL4 Control Bits */

/* FCTL4 Control Bits */

/************************************************************
* HARDWARE MULTIPLIER 32Bit
************************************************************/

extern volatile unsigned int MPY;                               /* Multiply Unsigned/Operand 1 */
extern volatile unsigned char MPY_L;                              /* Multiply Unsigned/Operand 1 */
extern volatile unsigned char MPY_H;                              /* Multiply Unsigned/Operand 1 */
extern volatile unsigned int MPYS;                              /* Multiply Signed/Operand 1 */
extern volatile unsigned char MPYS_L;                             /* Multiply Signed/Operand 1 */
extern volatile unsigned char MPYS_H;                             /* Multiply Signed/Operand 1 */
extern volatile unsigned int MAC;                               /* Multiply Unsigned and Accumulate/Operand 1 */
extern volatile unsigned char MAC_L;                              /* Multiply Unsigned and Accumulate/Operand 1 */
extern volatile unsigned char MAC_H;                              /* Multiply Unsigned and Accumulate/Operand 1 */
extern volatile unsigned int MACS;                              /* Multiply Signed and Accumulate/Operand 1 */
extern volatile unsigned char MACS_L;                             /* Multiply Signed and Accumulate/Operand 1 */
extern volatile unsigned char MACS_H;                             /* Multiply Signed and Accumulate/Operand 1 */
extern volatile unsigned int OP2;                               /* Operand 2 */
extern volatile unsigned char OP2_L;                              /* Operand 2 */
extern volatile unsigned char OP2_H;                              /* Operand 2 */
extern volatile unsigned int RESLO;                             /* Result Low Word */
extern volatile unsigned char RESLO_L;                            /* Result Low Word */
extern volatile unsigned char RESLO_H;                            /* Result Low Word */
extern volatile unsigned int RESHI;                             /* Result High Word */
extern volatile unsigned char RESHI_L;                            /* Result High Word */
extern volatile unsigned char RESHI_H;                            /* Result High Word */
extern volatile unsigned int SUMEXT;                            /* Sum Extend */
extern volatile unsigned char SUMEXT_L;                           /* Sum Extend */
extern volatile unsigned char SUMEXT_H;                           /* Sum Extend */

extern volatile unsigned int MPY32L;                            /* 32-bit operand 1 - multiply - low word */
extern volatile unsigned char MPY32L_L;                           /* 32-bit operand 1 - multiply - low word */
extern volatile unsigned char MPY32L_H;                           /* 32-bit operand 1 - multiply - low word */
extern volatile unsigned int MPY32H;                            /* 32-bit operand 1 - multiply - high word */
extern volatile unsigned char MPY32H_L;                           /* 32-bit operand 1 - multiply - high word */
extern volatile unsigned char MPY32H_H;                           /* 32-bit operand 1 - multiply - high word */
extern volatile unsigned int MPYS32L;                           /* 32-bit operand 1 - signed multiply - low word */
extern volatile unsigned char MPYS32L_L;                          /* 32-bit operand 1 - signed multiply - low word */
extern volatile unsigned char MPYS32L_H;                          /* 32-bit operand 1 - signed multiply - low word */
extern volatile unsigned int MPYS32H;                           /* 32-bit operand 1 - signed multiply - high word */
extern volatile unsigned char MPYS32H_L;                          /* 32-bit operand 1 - signed multiply - high word */
extern volatile unsigned char MPYS32H_H;                          /* 32-bit operand 1 - signed multiply - high word */
extern volatile unsigned int MAC32L;                            /* 32-bit operand 1 - multiply accumulate - low word */
extern volatile unsigned char MAC32L_L;                           /* 32-bit operand 1 - multiply accumulate - low word */
extern volatile unsigned char MAC32L_H;                           /* 32-bit operand 1 - multiply accumulate - low word */
extern volatile unsigned int MAC32H;                            /* 32-bit operand 1 - multiply accumulate - high word */
extern volatile unsigned char MAC32H_L;                           /* 32-bit operand 1 - multiply accumulate - high word */
extern volatile unsigned char MAC32H_H;                           /* 32-bit operand 1 - multiply accumulate - high word */
extern volatile unsigned int MACS32L;                           /* 32-bit operand 1 - signed multiply accumulate - low word */
extern volatile unsigned char MACS32L_L;                          /* 32-bit operand 1 - signed multiply accumulate - low word */
extern volatile unsigned char MACS32L_H;                          /* 32-bit operand 1 - signed multiply accumulate - low word */
extern volatile unsigned int MACS32H;                           /* 32-bit operand 1 - signed multiply accumulate - high word */
extern volatile unsigned char MACS32H_L;                          /* 32-bit operand 1 - signed multiply accumulate - high word */
extern volatile unsigned char MACS32H_H;                          /* 32-bit operand 1 - signed multiply accumulate - high word */
extern volatile unsigned int OP2L;                              /* 32-bit operand 2 - low word */
extern volatile unsigned char OP2L_L;                             /* 32-bit operand 2 - low word */
extern volatile unsigned char OP2L_H;                             /* 32-bit operand 2 - low word */
extern volatile unsigned int OP2H;                              /* 32-bit operand 2 - high word */
extern volatile unsigned char OP2H_L;                             /* 32-bit operand 2 - high word */
extern volatile unsigned char OP2H_H;                             /* 32-bit operand 2 - high word */
extern volatile unsigned int RES0;                              /* 32x32-bit result 0 - least significant word */
extern volatile unsigned char RES0_L;                             /* 32x32-bit result 0 - least significant word */
extern volatile unsigned char RES0_H;                             /* 32x32-bit result 0 - least significant word */
extern volatile unsigned int RES1;                              /* 32x32-bit result 1 */
extern volatile unsigned char RES1_L;                             /* 32x32-bit result 1 */
extern volatile unsigned char RES1_H;                             /* 32x32-bit result 1 */
extern volatile unsigned int RES2;                              /* 32x32-bit result 2 */
extern volatile unsigned char RES2_L;                             /* 32x32-bit result 2 */
extern volatile unsigned char RES2_H;                             /* 32x32-bit result 2 */
extern volatile unsigned int RES3;                              /* 32x32-bit result 3 - most significant word */
extern volatile unsigned char RES3_L;                             /* 32x32-bit result 3 - most significant word */
extern volatile unsigned char RES3_H;                             /* 32x32-bit result 3 - most significant word */
extern volatile unsigned int MPY32CTL0;                         /* MPY32 Control Register 0 */
extern volatile unsigned char MPY32CTL0_L;                        /* MPY32 Control Register 0 */
extern volatile unsigned char MPY32CTL0_H;                        /* MPY32 Control Register 0 */


/* MPY32CTL0 Control Bits */
//#define RESERVED            (0x0002)  /* Reserved */

/* MPY32CTL0 Control Bits */
//#define RESERVED            (0x0002)  /* Reserved */

/* MPY32CTL0 Control Bits */
//#define RESERVED            (0x0002)  /* Reserved */


/************************************************************
* DIGITAL I/O Port1/2 Pull up / Pull down Resistors
************************************************************/

extern volatile unsigned int PAIN;                              /* Port A Input */
extern volatile unsigned char PAIN_L;                             /* Port A Input */
extern volatile unsigned char PAIN_H;                             /* Port A Input */
extern volatile unsigned int PAOUT;                             /* Port A Output */
extern volatile unsigned char PAOUT_L;                            /* Port A Output */
extern volatile unsigned char PAOUT_H;                            /* Port A Output */
extern volatile unsigned int PADIR;                             /* Port A Direction */
extern volatile unsigned char PADIR_L;                            /* Port A Direction */
extern volatile unsigned char PADIR_H;                            /* Port A Direction */
extern volatile unsigned int PAREN;                             /* Port A Resistor Enable */
extern volatile unsigned char PAREN_L;                            /* Port A Resistor Enable */
extern volatile unsigned char PAREN_H;                            /* Port A Resistor Enable */
extern volatile unsigned int PADS;                              /* Port A Drive Strenght */
extern volatile unsigned char PADS_L;                             /* Port A Drive Strenght */
extern volatile unsigned char PADS_H;                             /* Port A Drive Strenght */
extern volatile unsigned int PASEL;                             /* Port A Selection */
extern volatile unsigned char PASEL_L;                            /* Port A Selection */
extern volatile unsigned char PASEL_H;                            /* Port A Selection */
extern volatile unsigned int PAIES;                             /* Port A Interrupt Edge Select */
extern volatile unsigned char PAIES_L;                            /* Port A Interrupt Edge Select */
extern volatile unsigned char PAIES_H;                            /* Port A Interrupt Edge Select */
extern volatile unsigned int PAIE;                              /* Port A Interrupt Enable */
extern volatile unsigned char PAIE_L;                             /* Port A Interrupt Enable */
extern volatile unsigned char PAIE_H;                             /* Port A Interrupt Enable */
extern volatile unsigned int PAIFG;                             /* Port A Interrupt Flag */
extern volatile unsigned char PAIFG_L;                            /* Port A Interrupt Flag */
extern volatile unsigned char PAIFG_H;                            /* Port A Interrupt Flag */


extern volatile unsigned int P1IV;                              /* Port 1 Interrupt Vector Word */
extern volatile unsigned int P2IV;                              /* Port 2 Interrupt Vector Word */

//Definitions for P1IV


//Definitions for P2IV


/************************************************************
* DIGITAL I/O Port3/4 Pull up / Pull down Resistors
************************************************************/

extern volatile unsigned int PBIN;                              /* Port B Input */
extern volatile unsigned char PBIN_L;                             /* Port B Input */
extern volatile unsigned char PBIN_H;                             /* Port B Input */
extern volatile unsigned int PBOUT;                             /* Port B Output */
extern volatile unsigned char PBOUT_L;                            /* Port B Output */
extern volatile unsigned char PBOUT_H;                            /* Port B Output */
extern volatile unsigned int PBDIR;                             /* Port B Direction */
extern volatile unsigned char PBDIR_L;                            /* Port B Direction */
extern volatile unsigned char PBDIR_H;                            /* Port B Direction */
extern volatile unsigned int PBREN;                             /* Port B Resistor Enable */
extern volatile unsigned char PBREN_L;                            /* Port B Resistor Enable */
extern volatile unsigned char PBREN_H;                            /* Port B Resistor Enable */
extern volatile unsigned int PBDS;                              /* Port B Drive Strenght */
extern volatile unsigned char PBDS_L;                             /* Port B Drive Strenght */
extern volatile unsigned char PBDS_H;                             /* Port B Drive Strenght */
extern volatile unsigned int PBSEL;                             /* Port B Selection */
extern volatile unsigned char PBSEL_L;                            /* Port B Selection */
extern volatile unsigned char PBSEL_H;                            /* Port B Selection */





/************************************************************
* DIGITAL I/O Port5/6 Pull up / Pull down Resistors
************************************************************/

extern volatile unsigned int PCIN;                              /* Port C Input */
extern volatile unsigned char PCIN_L;                             /* Port C Input */
extern volatile unsigned char PCIN_H;                             /* Port C Input */
extern volatile unsigned int PCOUT;                             /* Port C Output */
extern volatile unsigned char PCOUT_L;                            /* Port C Output */
extern volatile unsigned char PCOUT_H;                            /* Port C Output */
extern volatile unsigned int PCDIR;                             /* Port C Direction */
extern volatile unsigned char PCDIR_L;                            /* Port C Direction */
extern volatile unsigned char PCDIR_H;                            /* Port C Direction */
extern volatile unsigned int PCREN;                             /* Port C Resistor Enable */
extern volatile unsigned char PCREN_L;                            /* Port C Resistor Enable */
extern volatile unsigned char PCREN_H;                            /* Port C Resistor Enable */
extern volatile unsigned int PCDS;                              /* Port C Drive Strenght */
extern volatile unsigned char PCDS_L;                             /* Port C Drive Strenght */
extern volatile unsigned char PCDS_H;                             /* Port C Drive Strenght */
extern volatile unsigned int PCSEL;                             /* Port C Selection */
extern volatile unsigned char PCSEL_L;                            /* Port C Selection */
extern volatile unsigned char PCSEL_H;                            /* Port C Selection */





/************************************************************
* DIGITAL I/O PortJ Pull up / Pull down Resistors
************************************************************/

extern volatile unsigned int PJIN;                              /* Port J Input */
extern volatile unsigned char PJIN_L;                             /* Port J Input */
extern volatile unsigned char PJIN_H;                             /* Port J Input */
extern volatile unsigned int PJOUT;                             /* Port J Output */
extern volatile unsigned char PJOUT_L;                            /* Port J Output */
extern volatile unsigned char PJOUT_H;                            /* Port J Output */
extern volatile unsigned int PJDIR;                             /* Port J Direction */
extern volatile unsigned char PJDIR_L;                            /* Port J Direction */
extern volatile unsigned char PJDIR_H;                            /* Port J Direction */
extern volatile unsigned int PJREN;                             /* Port J Resistor Enable */
extern volatile unsigned char PJREN_L;                            /* Port J Resistor Enable */
extern volatile unsigned char PJREN_H;                            /* Port J Resistor Enable */
extern volatile unsigned int PJDS;                              /* Port J Drive Strenght */
extern volatile unsigned char PJDS_L;                             /* Port J Drive Strenght */
extern volatile unsigned char PJDS_H;                             /* Port J Drive Strenght */

/************************************************************
* PORT MAPPING CONTROLLER
************************************************************/

extern volatile unsigned int PMAPKEYID;                         /* Port Mapping Key register */
extern volatile unsigned char PMAPKEYID_L;                        /* Port Mapping Key register */
extern volatile unsigned char PMAPKEYID_H;                        /* Port Mapping Key register */
extern volatile unsigned int PMAPCTL;                           /* Port Mapping control register */
extern volatile unsigned char PMAPCTL_L;                          /* Port Mapping control register */
extern volatile unsigned char PMAPCTL_H;                          /* Port Mapping control register */


/* PMAPCTL Control Bits */

/* PMAPCTL Control Bits */

/************************************************************
* PORT 4 MAPPING CONTROLLER
************************************************************/

extern volatile unsigned int P4MAP01;                           /* Port P4.0/1 mapping register */
extern volatile unsigned char P4MAP01_L;                          /* Port P4.0/1 mapping register */
extern volatile unsigned char P4MAP01_H;                          /* Port P4.0/1 mapping register */
extern volatile unsigned int P4MAP23;                           /* Port P4.2/3 mapping register */
extern volatile unsigned char P4MAP23_L;                          /* Port P4.2/3 mapping register */
extern volatile unsigned char P4MAP23_H;                          /* Port P4.2/3 mapping register */
extern volatile unsigned int P4MAP45;                           /* Port P4.4/5 mapping register */
extern volatile unsigned char P4MAP45_L;                          /* Port P4.4/5 mapping register */
extern volatile unsigned char P4MAP45_H;                          /* Port P4.4/5 mapping register */
extern volatile unsigned int P4MAP67;                           /* Port P4.6/7 mapping register */
extern volatile unsigned char P4MAP67_L;                          /* Port P4.6/7 mapping register */
extern volatile unsigned char P4MAP67_H;                          /* Port P4.6/7 mapping register */



/************************************************************
* PMM - Power Management System
************************************************************/

extern volatile unsigned int PMMCTL0;                           /* PMM Control 0 */
extern volatile unsigned char PMMCTL0_L;                          /* PMM Control 0 */
extern volatile unsigned char PMMCTL0_H;                          /* PMM Control 0 */
extern volatile unsigned int PMMCTL1;                           /* PMM Control 1 */
extern volatile unsigned char PMMCTL1_L;                          /* PMM Control 1 */
extern volatile unsigned char PMMCTL1_H;                          /* PMM Control 1 */
extern volatile unsigned int SVSMHCTL;                          /* SVS and SVM high side control register */
extern volatile unsigned char SVSMHCTL_L;                         /* SVS and SVM high side control register */
extern volatile unsigned char SVSMHCTL_H;                         /* SVS and SVM high side control register */
extern volatile unsigned int SVSMLCTL;                          /* SVS and SVM low side control register */
extern volatile unsigned char SVSMLCTL_L;                         /* SVS and SVM low side control register */
extern volatile unsigned char SVSMLCTL_H;                         /* SVS and SVM low side control register */
extern volatile unsigned int SVSMIO;                            /* SVSIN and SVSOUT control register */
extern volatile unsigned char SVSMIO_L;                           /* SVSIN and SVSOUT control register */
extern volatile unsigned char SVSMIO_H;                           /* SVSIN and SVSOUT control register */
extern volatile unsigned int PMMIFG;                            /* PMM Interrupt Flag */
extern volatile unsigned char PMMIFG_L;                           /* PMM Interrupt Flag */
extern volatile unsigned char PMMIFG_H;                           /* PMM Interrupt Flag */
extern volatile unsigned int PMMRIE;                            /* PMM and RESET Interrupt Enable */
extern volatile unsigned char PMMRIE_L;                           /* PMM and RESET Interrupt Enable */
extern volatile unsigned char PMMRIE_H;                           /* PMM and RESET Interrupt Enable */
extern volatile unsigned int PM5CTL0;                           /* PMM Power Mode 5 Control Register 0 */
extern volatile unsigned char PM5CTL0_L;                          /* PMM Power Mode 5 Control Register 0 */
extern volatile unsigned char PM5CTL0_H;                          /* PMM Power Mode 5 Control Register 0 */


/* PMMCTL0 Control Bits */

/* PMMCTL0 Control Bits */


/* PMMCTL1 Control Bits */

/* PMMCTL1 Control Bits */

/* SVSMHCTL Control Bits */

/* SVSMHCTL Control Bits */

/* SVSMHCTL Control Bits */



/* SVSMLCTL Control Bits */

/* SVSMLCTL Control Bits */

/* SVSMLCTL Control Bits */



/* SVSMIO Control Bits */

/* SVSMIO Control Bits */

/* SVSMIO Control Bits */

/* PMMIFG Control Bits */

/* PMMIFG Control Bits */

/* PMMIFG Control Bits */


/* PMMIE and RESET Control Bits */

/* PMMIE and RESET Control Bits */

/* PMMIE and RESET Control Bits */

/* PM5CTL0 Power Mode 5 Control Bits */

/* PM5CTL0 Power Mode 5 Control Bits */


/*************************************************************
* RAM Control Module
*************************************************************/

extern volatile unsigned int RCCTL0;                            /* Ram Controller Control Register */
extern volatile unsigned char RCCTL0_L;                           /* Ram Controller Control Register */
extern volatile unsigned char RCCTL0_H;                           /* Ram Controller Control Register */

/* RCCTL0 Control Bits */

/* RCCTL0 Control Bits */


/************************************************************
* Shared Reference
************************************************************/

extern volatile unsigned int REFCTL0;                           /* REF Shared Reference control register 0 */
extern volatile unsigned char REFCTL0_L;                          /* REF Shared Reference control register 0 */
extern volatile unsigned char REFCTL0_H;                          /* REF Shared Reference control register 0 */

/* REFCTL0 Control Bits */
//#define RESERVED            (0x0004)  /* Reserved */
//#define RESERVED            (0x0040)  /* Reserved */
//#define RESERVED            (0x1000)  /* Reserved */
//#define RESERVED            (0x2000)  /* Reserved */
//#define RESERVED            (0x4000)  /* Reserved */
//#define RESERVED            (0x8000)  /* Reserved */

/* REFCTL0 Control Bits */
//#define RESERVED            (0x0004)  /* Reserved */
//#define RESERVED            (0x0040)  /* Reserved */
//#define RESERVED            (0x1000)  /* Reserved */
//#define RESERVED            (0x2000)  /* Reserved */
//#define RESERVED            (0x4000)  /* Reserved */
//#define RESERVED            (0x8000)  /* Reserved */

/* REFCTL0 Control Bits */
//#define RESERVED            (0x0004)  /* Reserved */
//#define RESERVED            (0x0040)  /* Reserved */
//#define RESERVED            (0x1000)  /* Reserved */
//#define RESERVED            (0x2000)  /* Reserved */
//#define RESERVED            (0x4000)  /* Reserved */
//#define RESERVED            (0x8000)  /* Reserved */


/************************************************************
* Real Time Clock
************************************************************/

extern volatile unsigned int RTCCTL01;                          /* Real Timer Control 0/1 */
extern volatile unsigned char RTCCTL01_L;                         /* Real Timer Control 0/1 */
extern volatile unsigned char RTCCTL01_H;                         /* Real Timer Control 0/1 */
extern volatile unsigned int RTCCTL23;                          /* Real Timer Control 2/3 */
extern volatile unsigned char RTCCTL23_L;                         /* Real Timer Control 2/3 */
extern volatile unsigned char RTCCTL23_H;                         /* Real Timer Control 2/3 */
extern volatile unsigned int RTCPS0CTL;                         /* Real Timer Prescale Timer 0 Control */
extern volatile unsigned char RTCPS0CTL_L;                        /* Real Timer Prescale Timer 0 Control */
extern volatile unsigned char RTCPS0CTL_H;                        /* Real Timer Prescale Timer 0 Control */
extern volatile unsigned int RTCPS1CTL;                         /* Real Timer Prescale Timer 1 Control */
extern volatile unsigned char RTCPS1CTL_L;                        /* Real Timer Prescale Timer 1 Control */
extern volatile unsigned char RTCPS1CTL_H;                        /* Real Timer Prescale Timer 1 Control */
extern volatile unsigned int RTCPS;                             /* Real Timer Prescale Timer Control */
extern volatile unsigned char RTCPS_L;                            /* Real Timer Prescale Timer Control */
extern volatile unsigned char RTCPS_H;                            /* Real Timer Prescale Timer Control */
extern volatile unsigned int RTCIV;                             /* Real Time Clock Interrupt Vector */
extern volatile unsigned int RTCTIM0;                           /* Real Time Clock Time 0 */
extern volatile unsigned char RTCTIM0_L;                          /* Real Time Clock Time 0 */
extern volatile unsigned char RTCTIM0_H;                          /* Real Time Clock Time 0 */
extern volatile unsigned int RTCTIM1;                           /* Real Time Clock Time 1 */
extern volatile unsigned char RTCTIM1_L;                          /* Real Time Clock Time 1 */
extern volatile unsigned char RTCTIM1_H;                          /* Real Time Clock Time 1 */
extern volatile unsigned int RTCDATE;                           /* Real Time Clock Date */
extern volatile unsigned char RTCDATE_L;                          /* Real Time Clock Date */
extern volatile unsigned char RTCDATE_H;                          /* Real Time Clock Date */
extern volatile unsigned int RTCYEAR;                           /* Real Time Clock Year */
extern volatile unsigned char RTCYEAR_L;                          /* Real Time Clock Year */
extern volatile unsigned char RTCYEAR_H;                          /* Real Time Clock Year */
extern volatile unsigned int RTCAMINHR;                         /* Real Time Clock Alarm Min/Hour */
extern volatile unsigned char RTCAMINHR_L;                        /* Real Time Clock Alarm Min/Hour */
extern volatile unsigned char RTCAMINHR_H;                        /* Real Time Clock Alarm Min/Hour */
extern volatile unsigned int RTCADOWDAY;                        /* Real Time Clock Alarm day of week/day */
extern volatile unsigned char RTCADOWDAY_L;                       /* Real Time Clock Alarm day of week/day */
extern volatile unsigned char RTCADOWDAY_H;                       /* Real Time Clock Alarm day of week/day */


/* RTCCTL01 Control Bits */
//#define Reserved          (0x0080)
//#define Reserved          (0x0008)

/* RTCCTL01 Control Bits */
//#define Reserved          (0x0080)
//#define Reserved          (0x0008)

/* RTCCTL01 Control Bits */
//#define Reserved          (0x0080)
//#define Reserved          (0x0008)


/* RTCCTL23 Control Bits */
//#define Reserved          (0x0040)

/* RTCCTL23 Control Bits */
//#define Reserved          (0x0040)

/* RTCCTL23 Control Bits */
//#define Reserved          (0x0040)



/* RTCPS0CTL Control Bits */
//#define Reserved          (0x8000)
//#define Reserved          (0x0400)
//#define Reserved          (0x0200)
//#define Reserved          (0x0080)
//#define Reserved          (0x0040)
//#define Reserved          (0x0020)

/* RTCPS0CTL Control Bits */
//#define Reserved          (0x8000)
//#define Reserved          (0x0400)
//#define Reserved          (0x0200)
//#define Reserved          (0x0080)
//#define Reserved          (0x0040)
//#define Reserved          (0x0020)

/* RTCPS0CTL Control Bits */
//#define Reserved          (0x8000)
//#define Reserved          (0x0400)
//#define Reserved          (0x0200)
//#define Reserved          (0x0080)
//#define Reserved          (0x0040)
//#define Reserved          (0x0020)



/* RTCPS1CTL Control Bits */
//#define Reserved          (0x0400)
//#define Reserved          (0x0200)
//#define Reserved          (0x0080)
//#define Reserved          (0x0040)
//#define Reserved          (0x0020)

/* RTCPS1CTL Control Bits */
//#define Reserved          (0x0400)
//#define Reserved          (0x0200)
//#define Reserved          (0x0080)
//#define Reserved          (0x0040)
//#define Reserved          (0x0020)

/* RTCPS1CTL Control Bits */
//#define Reserved          (0x0400)
//#define Reserved          (0x0200)
//#define Reserved          (0x0080)
//#define Reserved          (0x0040)
//#define Reserved          (0x0020)




/* RTC Definitions */

/* Legacy Definitions */

/************************************************************
* SFR - Special Function Register Module
************************************************************/

extern volatile unsigned int SFRIE1;                            /* Interrupt Enable 1 */
extern volatile unsigned char SFRIE1_L;                           /* Interrupt Enable 1 */
extern volatile unsigned char SFRIE1_H;                           /* Interrupt Enable 1 */

/* SFRIE1 Control Bits */
//#define Reserved          (0x0004)

//#define Reserved          (0x0004)

extern volatile unsigned int SFRIFG1;                           /* Interrupt Flag 1 */
extern volatile unsigned char SFRIFG1_L;                          /* Interrupt Flag 1 */
extern volatile unsigned char SFRIFG1_H;                          /* Interrupt Flag 1 */
/* SFRIFG1 Control Bits */
//#define Reserved          (0x0004)
//#define Reserved          (0x0020)

//#define Reserved          (0x0004)
//#define Reserved          (0x0020)

extern volatile unsigned int SFRRPCR;                           /* RESET Pin Control Register */
extern volatile unsigned char SFRRPCR_L;                          /* RESET Pin Control Register */
extern volatile unsigned char SFRRPCR_H;                          /* RESET Pin Control Register */
/* SFRRPCR Control Bits */


/************************************************************
* SYS - System Module
************************************************************/

extern volatile unsigned int SYSCTL;                            /* System control */
extern volatile unsigned char SYSCTL_L;                           /* System control */
extern volatile unsigned char SYSCTL_H;                           /* System control */
extern volatile unsigned int SYSBSLC;                           /* Boot strap configuration area */
extern volatile unsigned char SYSBSLC_L;                          /* Boot strap configuration area */
extern volatile unsigned char SYSBSLC_H;                          /* Boot strap configuration area */
extern volatile unsigned int SYSJMBC;                           /* JTAG mailbox control */
extern volatile unsigned char SYSJMBC_L;                          /* JTAG mailbox control */
extern volatile unsigned char SYSJMBC_H;                          /* JTAG mailbox control */
extern volatile unsigned int SYSJMBI0;                          /* JTAG mailbox input 0 */
extern volatile unsigned char SYSJMBI0_L;                         /* JTAG mailbox input 0 */
extern volatile unsigned char SYSJMBI0_H;                         /* JTAG mailbox input 0 */
extern volatile unsigned int SYSJMBI1;                          /* JTAG mailbox input 1 */
extern volatile unsigned char SYSJMBI1_L;                         /* JTAG mailbox input 1 */
extern volatile unsigned char SYSJMBI1_H;                         /* JTAG mailbox input 1 */
extern volatile unsigned int SYSJMBO0;                          /* JTAG mailbox output 0 */
extern volatile unsigned char SYSJMBO0_L;                         /* JTAG mailbox output 0 */
extern volatile unsigned char SYSJMBO0_H;                         /* JTAG mailbox output 0 */
extern volatile unsigned int SYSJMBO1;                          /* JTAG mailbox output 1 */
extern volatile unsigned char SYSJMBO1_L;                         /* JTAG mailbox output 1 */
extern volatile unsigned char SYSJMBO1_H;                         /* JTAG mailbox output 1 */

extern volatile unsigned int SYSBERRIV;                         /* Bus Error vector generator */
extern volatile unsigned char SYSBERRIV_L;                        /* Bus Error vector generator */
extern volatile unsigned char SYSBERRIV_H;                        /* Bus Error vector generator */
extern volatile unsigned int SYSUNIV;                           /* User NMI vector generator */
extern volatile unsigned char SYSUNIV_L;                          /* User NMI vector generator */
extern volatile unsigned char SYSUNIV_H;                          /* User NMI vector generator */
extern volatile unsigned int SYSSNIV;                           /* System NMI vector generator */
extern volatile unsigned char SYSSNIV_L;                          /* System NMI vector generator */
extern volatile unsigned char SYSSNIV_H;                          /* System NMI vector generator */
extern volatile unsigned int SYSRSTIV;                          /* Reset vector generator */
extern volatile unsigned char SYSRSTIV_L;                         /* Reset vector generator */
extern volatile unsigned char SYSRSTIV_H;                         /* Reset vector generator */

/* SYSCTL Control Bits */
//#define RESERVED            (0x0002)  /* SYS - Reserved */
//#define RESERVED            (0x0008)  /* SYS - Reserved */
//#define RESERVED            (0x0040)  /* SYS - Reserved */
//#define RESERVED            (0x0080)  /* SYS - Reserved */
//#define RESERVED            (0x0100)  /* SYS - Reserved */
//#define RESERVED            (0x0200)  /* SYS - Reserved */
//#define RESERVED            (0x0400)  /* SYS - Reserved */
//#define RESERVED            (0x0800)  /* SYS - Reserved */
//#define RESERVED            (0x1000)  /* SYS - Reserved */
//#define RESERVED            (0x2000)  /* SYS - Reserved */
//#define RESERVED            (0x4000)  /* SYS - Reserved */
//#define RESERVED            (0x8000)  /* SYS - Reserved */

/* SYSCTL Control Bits */
//#define RESERVED            (0x0002)  /* SYS - Reserved */
//#define RESERVED            (0x0008)  /* SYS - Reserved */
//#define RESERVED            (0x0040)  /* SYS - Reserved */
//#define RESERVED            (0x0080)  /* SYS - Reserved */
//#define RESERVED            (0x0100)  /* SYS - Reserved */
//#define RESERVED            (0x0200)  /* SYS - Reserved */
//#define RESERVED            (0x0400)  /* SYS - Reserved */
//#define RESERVED            (0x0800)  /* SYS - Reserved */
//#define RESERVED            (0x1000)  /* SYS - Reserved */
//#define RESERVED            (0x2000)  /* SYS - Reserved */
//#define RESERVED            (0x4000)  /* SYS - Reserved */
//#define RESERVED            (0x8000)  /* SYS - Reserved */

/* SYSBSLC Control Bits */
//#define RESERVED            (0x0008)  /* SYS - Reserved */
//#define RESERVED            (0x0010)  /* SYS - Reserved */
//#define RESERVED            (0x0020)  /* SYS - Reserved */
//#define RESERVED            (0x0040)  /* SYS - Reserved */
//#define RESERVED            (0x0080)  /* SYS - Reserved */
//#define RESERVED            (0x0100)  /* SYS - Reserved */
//#define RESERVED            (0x0200)  /* SYS - Reserved */
//#define RESERVED            (0x0400)  /* SYS - Reserved */
//#define RESERVED            (0x0800)  /* SYS - Reserved */
//#define RESERVED            (0x1000)  /* SYS - Reserved */
//#define RESERVED            (0x2000)  /* SYS - Reserved */

/* SYSBSLC Control Bits */
//#define RESERVED            (0x0008)  /* SYS - Reserved */
//#define RESERVED            (0x0010)  /* SYS - Reserved */
//#define RESERVED            (0x0020)  /* SYS - Reserved */
//#define RESERVED            (0x0040)  /* SYS - Reserved */
//#define RESERVED            (0x0080)  /* SYS - Reserved */
//#define RESERVED            (0x0100)  /* SYS - Reserved */
//#define RESERVED            (0x0200)  /* SYS - Reserved */
//#define RESERVED            (0x0400)  /* SYS - Reserved */
//#define RESERVED            (0x0800)  /* SYS - Reserved */
//#define RESERVED            (0x1000)  /* SYS - Reserved */
//#define RESERVED            (0x2000)  /* SYS - Reserved */

/* SYSBSLC Control Bits */
//#define RESERVED            (0x0008)  /* SYS - Reserved */
//#define RESERVED            (0x0010)  /* SYS - Reserved */
//#define RESERVED            (0x0020)  /* SYS - Reserved */
//#define RESERVED            (0x0040)  /* SYS - Reserved */
//#define RESERVED            (0x0080)  /* SYS - Reserved */
//#define RESERVED            (0x0100)  /* SYS - Reserved */
//#define RESERVED            (0x0200)  /* SYS - Reserved */
//#define RESERVED            (0x0400)  /* SYS - Reserved */
//#define RESERVED            (0x0800)  /* SYS - Reserved */
//#define RESERVED            (0x1000)  /* SYS - Reserved */
//#define RESERVED            (0x2000)  /* SYS - Reserved */

/* SYSJMBC Control Bits */
//#define RESERVED            (0x0020)  /* SYS - Reserved */
//#define RESERVED            (0x0100)  /* SYS - Reserved */
//#define RESERVED            (0x0200)  /* SYS - Reserved */
//#define RESERVED            (0x0400)  /* SYS - Reserved */
//#define RESERVED            (0x0800)  /* SYS - Reserved */
//#define RESERVED            (0x1000)  /* SYS - Reserved */
//#define RESERVED            (0x2000)  /* SYS - Reserved */
//#define RESERVED            (0x4000)  /* SYS - Reserved */
//#define RESERVED            (0x8000)  /* SYS - Reserved */

/* SYSJMBC Control Bits */
//#define RESERVED            (0x0020)  /* SYS - Reserved */
//#define RESERVED            (0x0100)  /* SYS - Reserved */
//#define RESERVED            (0x0200)  /* SYS - Reserved */
//#define RESERVED            (0x0400)  /* SYS - Reserved */
//#define RESERVED            (0x0800)  /* SYS - Reserved */
//#define RESERVED            (0x1000)  /* SYS - Reserved */
//#define RESERVED            (0x2000)  /* SYS - Reserved */
//#define RESERVED            (0x4000)  /* SYS - Reserved */
//#define RESERVED            (0x8000)  /* SYS - Reserved */


/* SYSUNIV Definitions */

/* SYSSNIV Definitions */

/* SYSRSTIV Definitions */

/************************************************************
* Timer0_A5
************************************************************/

extern volatile unsigned int TA0CTL;                            /* Timer0_A5 Control */
extern volatile unsigned int TA0CCTL0;                          /* Timer0_A5 Capture/Compare Control 0 */
extern volatile unsigned int TA0CCTL1;                          /* Timer0_A5 Capture/Compare Control 1 */
extern volatile unsigned int TA0CCTL2;                          /* Timer0_A5 Capture/Compare Control 2 */
extern volatile unsigned int TA0CCTL3;                          /* Timer0_A5 Capture/Compare Control 3 */
extern volatile unsigned int TA0CCTL4;                          /* Timer0_A5 Capture/Compare Control 4 */
extern volatile unsigned int TA0R;                              /* Timer0_A5 */
extern volatile unsigned int TA0CCR0;                           /* Timer0_A5 Capture/Compare 0 */
extern volatile unsigned int TA0CCR1;                           /* Timer0_A5 Capture/Compare 1 */
extern volatile unsigned int TA0CCR2;                           /* Timer0_A5 Capture/Compare 2 */
extern volatile unsigned int TA0CCR3;                           /* Timer0_A5 Capture/Compare 3 */
extern volatile unsigned int TA0CCR4;                           /* Timer0_A5 Capture/Compare 4 */
extern volatile unsigned int TA0IV;                             /* Timer0_A5 Interrupt Vector Word */
extern volatile unsigned int TA0EX0;                            /* Timer0_A5 Expansion Register 0 */

/* TAxCTL Control Bits */


/* TAxCCTLx Control Bits */


/* TAxEX0 Control Bits */


/* T0A5IV Definitions */

/* Legacy Defines */

/************************************************************
* Timer1_A3
************************************************************/

extern volatile unsigned int TA1CTL;                            /* Timer1_A3 Control */
extern volatile unsigned int TA1CCTL0;                          /* Timer1_A3 Capture/Compare Control 0 */
extern volatile unsigned int TA1CCTL1;                          /* Timer1_A3 Capture/Compare Control 1 */
extern volatile unsigned int TA1CCTL2;                          /* Timer1_A3 Capture/Compare Control 2 */
extern volatile unsigned int TA1R;                              /* Timer1_A3 */
extern volatile unsigned int TA1CCR0;                           /* Timer1_A3 Capture/Compare 0 */
extern volatile unsigned int TA1CCR1;                           /* Timer1_A3 Capture/Compare 1 */
extern volatile unsigned int TA1CCR2;                           /* Timer1_A3 Capture/Compare 2 */
extern volatile unsigned int TA1IV;                             /* Timer1_A3 Interrupt Vector Word */
extern volatile unsigned int TA1EX0;                            /* Timer1_A3 Expansion Register 0 */

/* Bits are already defined within the Timer0_Ax */

/* TA1IV Definitions */

/* Legacy Defines */

/************************************************************
* Timer2_A3
************************************************************/

extern volatile unsigned int TA2CTL;                            /* Timer2_A3 Control */
extern volatile unsigned int TA2CCTL0;                          /* Timer2_A3 Capture/Compare Control 0 */
extern volatile unsigned int TA2CCTL1;                          /* Timer2_A3 Capture/Compare Control 1 */
extern volatile unsigned int TA2CCTL2;                          /* Timer2_A3 Capture/Compare Control 2 */
extern volatile unsigned int TA2R;                              /* Timer2_A3 */
extern volatile unsigned int TA2CCR0;                           /* Timer2_A3 Capture/Compare 0 */
extern volatile unsigned int TA2CCR1;                           /* Timer2_A3 Capture/Compare 1 */
extern volatile unsigned int TA2CCR2;                           /* Timer2_A3 Capture/Compare 2 */
extern volatile unsigned int TA2IV;                             /* Timer2_A3 Interrupt Vector Word */
extern volatile unsigned int TA2EX0;                            /* Timer2_A3 Expansion Register 0 */

/* Bits are already defined within the Timer0_Ax */

/* TA2IV Definitions */

/* Legacy Defines */

/************************************************************
* Timer0_B7
************************************************************/

extern volatile unsigned int TB0CTL;                            /* Timer0_B7 Control */
extern volatile unsigned int TB0CCTL0;                          /* Timer0_B7 Capture/Compare Control 0 */
extern volatile unsigned int TB0CCTL1;                          /* Timer0_B7 Capture/Compare Control 1 */
extern volatile unsigned int TB0CCTL2;                          /* Timer0_B7 Capture/Compare Control 2 */
extern volatile unsigned int TB0CCTL3;                          /* Timer0_B7 Capture/Compare Control 3 */
extern volatile unsigned int TB0CCTL4;                          /* Timer0_B7 Capture/Compare Control 4 */
extern volatile unsigned int TB0CCTL5;                          /* Timer0_B7 Capture/Compare Control 5 */
extern volatile unsigned int TB0CCTL6;                          /* Timer0_B7 Capture/Compare Control 6 */
extern volatile unsigned int TB0R;                              /* Timer0_B7 */
extern volatile unsigned int TB0CCR0;                           /* Timer0_B7 Capture/Compare 0 */
extern volatile unsigned int TB0CCR1;                           /* Timer0_B7 Capture/Compare 1 */
extern volatile unsigned int TB0CCR2;                           /* Timer0_B7 Capture/Compare 2 */
extern volatile unsigned int TB0CCR3;                           /* Timer0_B7 Capture/Compare 3 */
extern volatile unsigned int TB0CCR4;                           /* Timer0_B7 Capture/Compare 4 */
extern volatile unsigned int TB0CCR5;                           /* Timer0_B7 Capture/Compare 5 */
extern volatile unsigned int TB0CCR6;                           /* Timer0_B7 Capture/Compare 6 */
extern volatile unsigned int TB0EX0;                            /* Timer0_B7 Expansion Register 0 */
extern volatile unsigned int TB0IV;                             /* Timer0_B7 Interrupt Vector Word */

/* Legacy Type Definitions for TimerB */

/* TBxCTL Control Bits */



/* Additional Timer B Control Register bits are defined in Timer A */
/* TBxCCTLx Control Bits */




/* TBxEX0 Control Bits */


/* TB0IV Definitions */

/* Legacy Defines */


/************************************************************
* UNIFIED CLOCK SYSTEM
************************************************************/

extern volatile unsigned int UCSCTL0;                           /* UCS Control Register 0 */
extern volatile unsigned char UCSCTL0_L;                          /* UCS Control Register 0 */
extern volatile unsigned char UCSCTL0_H;                          /* UCS Control Register 0 */
extern volatile unsigned int UCSCTL1;                           /* UCS Control Register 1 */
extern volatile unsigned char UCSCTL1_L;                          /* UCS Control Register 1 */
extern volatile unsigned char UCSCTL1_H;                          /* UCS Control Register 1 */
extern volatile unsigned int UCSCTL2;                           /* UCS Control Register 2 */
extern volatile unsigned char UCSCTL2_L;                          /* UCS Control Register 2 */
extern volatile unsigned char UCSCTL2_H;                          /* UCS Control Register 2 */
extern volatile unsigned int UCSCTL3;                           /* UCS Control Register 3 */
extern volatile unsigned char UCSCTL3_L;                          /* UCS Control Register 3 */
extern volatile unsigned char UCSCTL3_H;                          /* UCS Control Register 3 */
extern volatile unsigned int UCSCTL4;                           /* UCS Control Register 4 */
extern volatile unsigned char UCSCTL4_L;                          /* UCS Control Register 4 */
extern volatile unsigned char UCSCTL4_H;                          /* UCS Control Register 4 */
extern volatile unsigned int UCSCTL5;                           /* UCS Control Register 5 */
extern volatile unsigned char UCSCTL5_L;                          /* UCS Control Register 5 */
extern volatile unsigned char UCSCTL5_H;                          /* UCS Control Register 5 */
extern volatile unsigned int UCSCTL6;                           /* UCS Control Register 6 */
extern volatile unsigned char UCSCTL6_L;                          /* UCS Control Register 6 */
extern volatile unsigned char UCSCTL6_H;                          /* UCS Control Register 6 */
extern volatile unsigned int UCSCTL7;                           /* UCS Control Register 7 */
extern volatile unsigned char UCSCTL7_L;                          /* UCS Control Register 7 */
extern volatile unsigned char UCSCTL7_H;                          /* UCS Control Register 7 */
extern volatile unsigned int UCSCTL8;                           /* UCS Control Register 8 */
extern volatile unsigned char UCSCTL8_L;                          /* UCS Control Register 8 */
extern volatile unsigned char UCSCTL8_H;                          /* UCS Control Register 8 */
extern volatile unsigned int UCSCTL9;                           /* UCS Control Register 9 */
extern volatile unsigned char UCSCTL9_L;                          /* UCS Control Register 9 */
extern volatile unsigned char UCSCTL9_H;                          /* UCS Control Register 9 */

/* UCSCTL0 Control Bits */
//#define RESERVED            (0x0001)    /* RESERVED */
//#define RESERVED            (0x0002)    /* RESERVED */
//#define RESERVED            (0x0004)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL0 Control Bits */
//#define RESERVED            (0x0001)    /* RESERVED */
//#define RESERVED            (0x0002)    /* RESERVED */
//#define RESERVED            (0x0004)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL0 Control Bits */
//#define RESERVED            (0x0001)    /* RESERVED */
//#define RESERVED            (0x0002)    /* RESERVED */
//#define RESERVED            (0x0004)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL1 Control Bits */
//#define RESERVED            (0x0002)    /* RESERVED */
//#define RESERVED            (0x0004)    /* RESERVED */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0100)    /* RESERVED */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL1 Control Bits */
//#define RESERVED            (0x0002)    /* RESERVED */
//#define RESERVED            (0x0004)    /* RESERVED */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0100)    /* RESERVED */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */


/* UCSCTL2 Control Bits */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL2 Control Bits */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL2 Control Bits */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */


/* UCSCTL3 Control Bits */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0100)    /* RESERVED */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL3 Control Bits */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0100)    /* RESERVED */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */


/* UCSCTL4 Control Bits */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL4 Control Bits */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL4 Control Bits */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */




/* UCSCTL5 Control Bits */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL5 Control Bits */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL5 Control Bits */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */





/* UCSCTL6 Control Bits */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */

/* UCSCTL6 Control Bits */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */

/* UCSCTL6 Control Bits */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */


/* UCSCTL7 Control Bits */
//#define RESERVED            (0x0004)    /* RESERVED */
//#define RESERVED            (0x0010)    /* RESERVED */
//#define RESERVED            (0x0020)    /* RESERVED */
//#define RESERVED            (0x0040)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0100)    /* RESERVED */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL7 Control Bits */
//#define RESERVED            (0x0004)    /* RESERVED */
//#define RESERVED            (0x0010)    /* RESERVED */
//#define RESERVED            (0x0020)    /* RESERVED */
//#define RESERVED            (0x0040)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0100)    /* RESERVED */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL8 Control Bits */
//#define RESERVED            (0x0010)    /* RESERVED */
//#define RESERVED            (0x0020)    /* RESERVED */
//#define RESERVED            (0x0040)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0100)    /* RESERVED */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL8 Control Bits */
//#define RESERVED            (0x0010)    /* RESERVED */
//#define RESERVED            (0x0020)    /* RESERVED */
//#define RESERVED            (0x0040)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0100)    /* RESERVED */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL9 Control Bits */
//#define RESERVED            (0x0004)    /* RESERVED */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0010)    /* RESERVED */
//#define RESERVED            (0x0020)    /* RESERVED */
//#define RESERVED            (0x0040)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0100)    /* RESERVED */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/* UCSCTL9 Control Bits */
//#define RESERVED            (0x0004)    /* RESERVED */
//#define RESERVED            (0x0008)    /* RESERVED */
//#define RESERVED            (0x0010)    /* RESERVED */
//#define RESERVED            (0x0020)    /* RESERVED */
//#define RESERVED            (0x0040)    /* RESERVED */
//#define RESERVED            (0x0080)    /* RESERVED */
//#define RESERVED            (0x0100)    /* RESERVED */
//#define RESERVED            (0x0200)    /* RESERVED */
//#define RESERVED            (0x0400)    /* RESERVED */
//#define RESERVED            (0x0800)    /* RESERVED */
//#define RESERVED            (0x1000)    /* RESERVED */
//#define RESERVED            (0x2000)    /* RESERVED */
//#define RESERVED            (0x4000)    /* RESERVED */
//#define RESERVED            (0x8000)    /* RESERVED */

/************************************************************
* USCI A0
************************************************************/

extern volatile unsigned int UCA0CTLW0;                         /* USCI A0 Control Word Register 0 */
extern volatile unsigned char UCA0CTLW0_L;                        /* USCI A0 Control Word Register 0 */
extern volatile unsigned char UCA0CTLW0_H;                        /* USCI A0 Control Word Register 0 */
extern volatile unsigned int UCA0BRW;                           /* USCI A0 Baud Word Rate 0 */
extern volatile unsigned char UCA0BRW_L;                          /* USCI A0 Baud Word Rate 0 */
extern volatile unsigned char UCA0BRW_H;                          /* USCI A0 Baud Word Rate 0 */
extern volatile unsigned char UCA0MCTL;                           /* USCI A0 Modulation Control */
extern volatile unsigned char UCA0STAT;                           /* USCI A0 Status Register */
extern volatile unsigned char UCA0RXBUF;                          /* USCI A0 Receive Buffer */
extern volatile unsigned char UCA0TXBUF;                          /* USCI A0 Transmit Buffer */
extern volatile unsigned char UCA0ABCTL;                          /* USCI A0 LIN Control */
extern volatile unsigned int UCA0IRCTL;                         /* USCI A0 IrDA Transmit Control */
extern volatile unsigned char UCA0IRCTL_L;                        /* USCI A0 IrDA Transmit Control */
extern volatile unsigned char UCA0IRCTL_H;                        /* USCI A0 IrDA Transmit Control */
extern volatile unsigned int UCA0ICTL;                          /* USCI A0 Interrupt Enable Register */
extern volatile unsigned char UCA0ICTL_L;                         /* USCI A0 Interrupt Enable Register */
extern volatile unsigned char UCA0ICTL_H;                         /* USCI A0 Interrupt Enable Register */
extern volatile unsigned int UCA0IV;                            /* USCI A0 Interrupt Vector Register */


/************************************************************
* USCI B0
************************************************************/


extern volatile unsigned int UCB0CTLW0;                         /* USCI B0 Control Word Register 0 */
extern volatile unsigned char UCB0CTLW0_L;                        /* USCI B0 Control Word Register 0 */
extern volatile unsigned char UCB0CTLW0_H;                        /* USCI B0 Control Word Register 0 */
extern volatile unsigned int UCB0BRW;                           /* USCI B0 Baud Word Rate 0 */
extern volatile unsigned char UCB0BRW_L;                          /* USCI B0 Baud Word Rate 0 */
extern volatile unsigned char UCB0BRW_H;                          /* USCI B0 Baud Word Rate 0 */
extern volatile unsigned char UCB0STAT;                           /* USCI B0 Status Register */
extern volatile unsigned char UCB0RXBUF;                          /* USCI B0 Receive Buffer */
extern volatile unsigned char UCB0TXBUF;                          /* USCI B0 Transmit Buffer */
extern volatile unsigned int UCB0I2COA;                         /* USCI B0 I2C Own Address */
extern volatile unsigned char UCB0I2COA_L;                        /* USCI B0 I2C Own Address */
extern volatile unsigned char UCB0I2COA_H;                        /* USCI B0 I2C Own Address */
extern volatile unsigned int UCB0I2CSA;                         /* USCI B0 I2C Slave Address */
extern volatile unsigned char UCB0I2CSA_L;                        /* USCI B0 I2C Slave Address */
extern volatile unsigned char UCB0I2CSA_H;                        /* USCI B0 I2C Slave Address */
extern volatile unsigned int UCB0ICTL;                          /* USCI B0 Interrupt Enable Register */
extern volatile unsigned char UCB0ICTL_L;                         /* USCI B0 Interrupt Enable Register */
extern volatile unsigned char UCB0ICTL_H;                         /* USCI B0 Interrupt Enable Register */
extern volatile unsigned int UCB0IV;                            /* USCI B0 Interrupt Vector Register */

// UCAxCTL0 UART-Mode Control Bits

// UCxxCTL0 SPI-Mode Control Bits

// UCBxCTL0 I2C-Mode Control Bits
//#define res               (0x10)    /* reserved */

// UCAxCTL1 UART-Mode Control Bits

// UCxxCTL1 SPI-Mode Control Bits
//#define res               (0x20)    /* reserved */
//#define res               (0x10)    /* reserved */
//#define res               (0x08)    /* reserved */
//#define res               (0x04)    /* reserved */
//#define res               (0x02)    /* reserved */

// UCBxCTL1 I2C-Mode Control Bits
//#define res               (0x20)    /* reserved */

/* UCAxMCTL Control Bits */



/* UCAxSTAT Control Bits */

/* UCBxSTAT Control Bits */

/* UCAxIRTCTL Control Bits */

/* UCAxIRRCTL Control Bits */

/* UCAxABCTL Control Bits */
//#define res               (0x80)    /* reserved */
//#define res               (0x40)    /* reserved */
//#define res               (0x02)    /* reserved */

/* UCBxI2COA Control Bits */

/* UCBxI2COA Control Bits */

/* UCBxI2COA Control Bits */

/* UCBxI2CSA Control Bits */

/* UCBxI2CSA Control Bits */

/* UCBxI2CSA Control Bits */

/* UCAxIE Control Bits */

/* UCBxIE Control Bits */

/* UCAxIFG Control Bits */

/* UCBxIFG Control Bits */

/* USCI Interrupt Vector Definitions */

/************************************************************
* USCI A1
************************************************************/

extern volatile unsigned int UCA1CTLW0;                         /* USCI A1 Control Word Register 0 */
extern volatile unsigned char UCA1CTLW0_L;                        /* USCI A1 Control Word Register 0 */
extern volatile unsigned char UCA1CTLW0_H;                        /* USCI A1 Control Word Register 0 */
extern volatile unsigned int UCA1BRW;                           /* USCI A1 Baud Word Rate 0 */
extern volatile unsigned char UCA1BRW_L;                          /* USCI A1 Baud Word Rate 0 */
extern volatile unsigned char UCA1BRW_H;                          /* USCI A1 Baud Word Rate 0 */
extern volatile unsigned char UCA1MCTL;                           /* USCI A1 Modulation Control */
extern volatile unsigned char UCA1STAT;                           /* USCI A1 Status Register */
extern volatile unsigned char UCA1RXBUF;                          /* USCI A1 Receive Buffer */
extern volatile unsigned char UCA1TXBUF;                          /* USCI A1 Transmit Buffer */
extern volatile unsigned char UCA1ABCTL;                          /* USCI A1 LIN Control */
extern volatile unsigned int UCA1IRCTL;                         /* USCI A1 IrDA Transmit Control */
extern volatile unsigned char UCA1IRCTL_L;                        /* USCI A1 IrDA Transmit Control */
extern volatile unsigned char UCA1IRCTL_H;                        /* USCI A1 IrDA Transmit Control */
extern volatile unsigned int UCA1ICTL;                          /* USCI A1 Interrupt Enable Register */
extern volatile unsigned char UCA1ICTL_L;                         /* USCI A1 Interrupt Enable Register */
extern volatile unsigned char UCA1ICTL_H;                         /* USCI A1 Interrupt Enable Register */
extern volatile unsigned int UCA1IV;                            /* USCI A1 Interrupt Vector Register */


/************************************************************
* USCI B1
************************************************************/


extern volatile unsigned int UCB1CTLW0;                         /* USCI B1 Control Word Register 0 */
extern volatile unsigned char UCB1CTLW0_L;                        /* USCI B1 Control Word Register 0 */
extern volatile unsigned char UCB1CTLW0_H;                        /* USCI B1 Control Word Register 0 */
extern volatile unsigned int UCB1BRW;                           /* USCI B1 Baud Word Rate 0 */
extern volatile unsigned char UCB1BRW_L;                          /* USCI B1 Baud Word Rate 0 */
extern volatile unsigned char UCB1BRW_H;                          /* USCI B1 Baud Word Rate 0 */
extern volatile unsigned char UCB1STAT;                           /* USCI B1 Status Register */
extern volatile unsigned char UCB1RXBUF;                          /* USCI B1 Receive Buffer */
extern volatile unsigned char UCB1TXBUF;                          /* USCI B1 Transmit Buffer */
extern volatile unsigned int UCB1I2COA;                         /* USCI B1 I2C Own Address */
extern volatile unsigned char UCB1I2COA_L;                        /* USCI B1 I2C Own Address */
extern volatile unsigned char UCB1I2COA_H;                        /* USCI B1 I2C Own Address */
extern volatile unsigned int UCB1I2CSA;                         /* USCI B1 I2C Slave Address */
extern volatile unsigned char UCB1I2CSA_L;                        /* USCI B1 I2C Slave Address */
extern volatile unsigned char UCB1I2CSA_H;                        /* USCI B1 I2C Slave Address */
extern volatile unsigned int UCB1ICTL;                          /* USCI B1 Interrupt Enable Register */
extern volatile unsigned char UCB1ICTL_L;                         /* USCI B1 Interrupt Enable Register */
extern volatile unsigned char UCB1ICTL_H;                         /* USCI B1 Interrupt Enable Register */
extern volatile unsigned int UCB1IV;                            /* USCI B1 Interrupt Vector Register */

/************************************************************
* WATCHDOG TIMER A
************************************************************/

extern volatile unsigned int WDTCTL;                            /* Watchdog Timer Control */
extern volatile unsigned char WDTCTL_L;                           /* Watchdog Timer Control */
extern volatile unsigned char WDTCTL_H;                           /* Watchdog Timer Control */
/* The bit names have been prefixed with "WDT" */
/* WDTCTL Control Bits */

/* WDTCTL Control Bits */




/* WDT-interval times [1ms] coded with Bits 0-2 */
/* WDT is clocked by fSMCLK (assumed 1MHz) */
/* WDT is clocked by fACLK (assumed 32KHz) */
/* Watchdog mode -> reset after expired time */
/* WDT is clocked by fSMCLK (assumed 1MHz) */
/* WDT is clocked by fACLK (assumed 32KHz) */


/************************************************************
* TLV Descriptors
************************************************************/



/************************************************************
* Interrupt Vectors (offset from 0xFF80)
************************************************************/

#pragma diag_suppress 1107



/************************************************************
* End of Modules
************************************************************/



/*
 * Configuracion_Radio.h
 *
 *  Created on: 11/04/2013
 *      Author: LUIS J. LPEZ
 */

//#define SNIFFER



//CANAL COMUNICACIONES

////////////////////////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//Optimal values for use CC1101 with CC1190




//CONFIGURACIN MODIFICABLE DE LA RADIO POR REGISTROS:
/*
 * {REG_FREQ2,       0x20},
		{REG_FREQ1,       0x2F},
		{REG_FREQ0,       0x68},
 */







//REGISTRO FREQ 2 = 0x0D




















/*
 * Flash.h
 *
 *  Created on: 25/03/2014
 *      Author: Usuario
 */




//Versin de Firmware:

//#define SNIFFER
//#define NO_RECONOZCAS_COORDINADOR



//#define SIMULA_REGISTRO_MODBUS_CON_VALORES_ALEATORIOS



//#define NO_RECONOZCAS_COORDINADOR










//#define PRUEBA_DMA_SEGUNDOPLANO
//#define DMACOLAMSG




//#define SIN_BUS_OCUPADO


//#define ONEWIRE
//#ifdef ONEWIRE
//#define ON_P2				1
//#define ONE_WIRE_PIN		ON_P2
//#define NO_IMPLEMENTADO		0
//#define IMPLEMENTADO		1
////ONEWIRE chips
//#define DS2417	NO_IMPLEMENTADO




//#include "TI_aes.h"




//#define PULSO_OFF_PWM		5u
//#define PULSO_ON_PWM		6u
//#define SALIDA_PURA			2u
//#define SALIDA_PWM			3u
//#define SOLO_PULSO			7u
//#define BOTH_PULSOS_PWM		8u



//#define READY		2
//#define NOT_READY	4
//
////BROADCAST ID

//
////Escape de los while:
//
////Tiempo para rehabilitar la recepcin de broadcast tras recibir uno:
//
//
//
////UART_RS485_CONFIGURATION


//
////RS485


//DMA CANALES:



//#define SSEL_2 				0x30


//#define _2HORAS_2MS			3600000ul//2*3600*500 = 3600000

//#define BAUDRATE_115200		0x03




//#define CHANNEL_FREE		0
//#define CHANNEL_BUSY		1

//#define CONNECTED			1
//#define DISCONNECTED		0


//Cmo contar los pulsos, por bajada o por subida, o por ambos:

//Estado de la radio




/////////////////////////////////////////////////////////////////////////////////////////
//PINES

//XT1

//UART_RS485_PINS

//SPI RADIO INTERFACE

//RADIO CONTROL

//Contador Pulsos:

//LEDS:

//USB connected

//USB UART

//USB UART

//DM108_OUTPUT

//ONEWIRE

//RADIO VOLTAGE CONTROL PIN

//SALIDA DISCRETA:


/////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////
//MACROS

//ONE_WIRE












/////////////////////////////////////////////////////////////////////////////////////////

//FLAGS INTERRUPCION SPI

//tengo que ver los flags de interrupcin
//#define SPI_TXIFG 			0x80
//#define SPI_RXIFG 			0x40

//COLA MENSAJES DEFINES:


//tiempo aleatorio mximo para el envo de tramas va radio
//#define TIEMPO_MAXIMO_ALEATORIO_ACK		10000	//5 ms

//Control de RX de la radio


//Numero maximo de reintentos para establecer comunicacin va radio. Si se cumple, se borra el nodo de la tabla.



//#define TIMER_COUNT_FOR_2MS_APROX	65 //13828096	27656,192	6914,048
//#define TIMER_COUNT_FOR_2MS_APROX	24576//(0,002 * 12288000)		//65 //0,002 * 32768
//#define TIMER_COUNT_FOR_500US_APROX	6144//(0,0005 * 12288000)


//POSICIONES DE LOS BYTES DE CONFIGURACIN:
//OJO//                                         //Memoria Fsica = 0x1984
//////                                          //Memoria Fsica = 0x1986
//#define POS_BYTE_TIMEOUT_MODBUS_H		14      //Memoria Fsica = 0x1990
//#define POS_BYTE_TIMEOUT_MODBUS_L		15      //Memoria Fsica = 0x1992



//#define POS_BYTE_CONF_GUARDADA			(POS_BYTE_NUM_ACKS_A_ENVIAR_L + 1u)		//Memoria Fsica = 0x1996





//AL UTILIZAR UNA UNION, PRIMERO GUARDO EL BYTE MENOS SIGNIFICATIVO!!!!



////////////////////////////////////////////////////////
//Posiciones de memoria
//SALIDA DIGITAL!!


////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//operaciones en ram:
//#define SIZE_DIV32	0x58ul
//#define SIZE_DIV16	0
//#define SIZE_MUL32	0
//#define SIZE_MUL16	0x18ul

//VAMOS A UTILIZAR LA MEMORIA ALTA FLASH2 PARA LAS OPS


//VAMOS A UTILIZAR LA MEMORIA ALTA FLASH2






////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//TABLA NODOS COORDINADOR:



/////////////////////////////////////////////////////////////////
//TABLA RSSI
/*#define DIR_INI_TABLA_RSSI			ORIGIN_TABLA_RSSI//0xF800u
#define NBYTES_X_RADIOID		4
#define NUM_RADIO_IDS_TABLA		50
#define NUM_REGISTROS_MODBUS_TABLA_RSSI		((NBYTES_X_RADIOID * NUM_RADIO_IDS_TABLA)/2)

#define PRIMER_REGISTRO_TABLA_RSSI	0x1004u
#define MASK_REGMB_2_MEMADDR		(DIR_INI_TABLA_RSSI - PRIMER_REGISTRO_TABLA_RSSI)
#define LAST_REGISTRO_TABLA_RSSI	(PRIMER_REGISTRO_TABLA_RSSI + NUM_REGISTROS_MODBUS_TABLA_RSSI)

#define POS_FROM_ID				2
#define POS_FROM_ID_VIRTUAL		4

#define POS_NUM_IDS_SAVED		1
#define POS_RADIO_H				0
#define POS_RADIO_L				1
#define POS_RSSI				2
#define POS_LQI					3*/
/////////////////////////////////////////////////////////////////

//#define HABILITA_INTERRUPCIONES()		_enable_interrupts()

//Para hacer el backup de los pulsos cada 5 minutos y as salvaguardar la flash...
//#define TIEMPO_BACKUP_PULSOS	150250 //APROX!!




//Para reseteo remoto:





//RESERVA DE 1KB de MEMORIA DE FLASH1 PARA LOS BORRADOS. Me sobra memoria! ;)




//#define DIR_MEMORIA_FLASH_LIBRE		0x5000ul



//
//#define ID_SLAVE	0x03
//#define ID_MASTER	0x01

//#define TIEMPO_SILENCIO_ENTRE_TRAMAS	50







//Funciones ModBus
//#define F15		0x0F	//Write Multiple Coils

//ERROR CODES:
//#define CODE_4	0x04	//Slave Device Failure
//#define CODE_5	0x05	//ACK para prevenir timeouts en procesos largos
//#define CODE_6	0x06	//Slave Device Busy
//#define CODE_8	0x08	//Memory parity Error
//#define CODE_10	0x0A	//Gateway Path unavailable
//#define CODE_11	0x0B	//Gateway Target Device




/********************************************************************************************/
//SALIDA DEL DM108:
//Los tres modos son excluyentes entre s: si un modo se activa, inmediatamente se desactivan los otros 2 (si es que alguno estaba activo)
//duraciones:
/*************************************************************************************************/

/***********************************/
//REGISTROS PARA VER LA TABLA DE NODOS CON LAS RUTAS!

//Son 14 bytes (7 registros) por cada nodo: 2 bytes Radio ID, 2 bytes Modbus ID (byte bajo,el alto no se utiliza), 10 bytes de ruta




//EL NMERO de registros ser: 64 Nodos x 7 registros -> 448 registros
//...

/***********************************/



//PARA EL WMCONFIGTOOL
//#define REG_MB_MODO_ACTUAL_PULSO		106	//Para saber el modo sin activarlo en s!



//#define REG_PASSWORD_BSL				50000



//Para el PUTO WM CONFIG TOOL: Slo LECTURA para los nuevos datos:!
/*
 * Pulsos - 2 registros
 * Modo Pulso - 1 registro
 * Numero Serie - 2 registros
 * Minutos Sin Actividad - 1 registro
 * Retardo en TX - 1 registro
 * Todas las opciones de SALIDA: 6 registros
 */



//TABLA RSSI:






/**
 * Copyright (c) 2011, Institute of Electronics and Computer Science
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *  * Redistributions of source code must retain the above copyright notice,
 *    this list of  conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * cc1101.h -- CC1101 radio driver
 */





/*
 * Configuracion_Radio.h
 *
 *  Created on: 11/04/2013
 *      Author: LUIS J. LPEZ
 */

//#define SNIFFER



//CANAL COMUNICACIONES

////////////////////////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//Optimal values for use CC1101 with CC1190




//CONFIGURACIN MODIFICABLE DE LA RADIO POR REGISTROS:
/*
 * {REG_FREQ2,       0x20},
		{REG_FREQ1,       0x2F},
		{REG_FREQ0,       0x68},
 */







//REGISTRO FREQ 2 = 0x0D





















//#define BDR38412_20dBm_869524759Hz

//#define F868

//#define BDR38400
//#define PRUEBA_869_MAX_SENSIVITY_26dBm
//#define LAST_TEST
//#define BDRATE_19200


//#define CONFIG_RADIO_KIT_TEXAS







//#define TX_FIFO_SIZE	25

//#define VAL_PKTCTRL0

//VALORES DE REGISTROS CHIP RADIO




//Registros de CC1101
// Strobe commands
// Status registers
// Other memory locations


//////////////////////////////////////////////////////////////////
//For CC430 FUNCTIONS
// Bit fields in the chip status byte

//// Chip states: los que utilizo realmente:
//#define CC1101_STATE_IDLE						0x01u
//#define CC1101_STATE_RX							0x0Du
////#define CC1101_STATE_RX_END						0x0E
//#define CC1101_STATE_RX_RST						0x0Fu
////#define CC1101_STATE_TX                        0x20
////#define CC1101_STATE_FSTXON                    0x30
////#define CC1101_STATE_CALIBRATE                 0x40
////#define CC1101_STATE_SETTLING                  0x50
////#define CC1101_STATE_RX_OVERFLOW               0x60
////#define CC1101_STATE_TX_UNDERFLOW              0x70


//----------------------------------------------------------------------------------
// Other register bit fields
//----------------------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////


// Masks for appended status bytes
// Definitions to support burst/single access:

//Machine State Control:


//Potencias de Transmisin Radio con AMPLIFICADOR!!!

//BITS PKTCTRL1

//BITS PKTCTRL0
//FIFO VALUES
//BITS MCSM0
//BITS MCSM1

//Main Radio Control States:
//#define RX_STATE 	0x0D



//#ifdef BDR38412_20dBm_869524759Hz
//static const unsigned char register_values[REG_ROW][REG_COL] =
//{
//  {REG_IOCFG2,            0x29},
//  {REG_IOCFG1,            0x2E},
//  {REG_IOCFG0,            VAL_IOCFG0}, //0x06},
//  {REG_FIFOTHR,           OPTIMAL_RX_FIFOTHR_VAL}, //0xC7},
//  {REG_SYNC1,             0xD3},
//  {REG_SYNC0,             0x91},
//  {REG_PKTLEN,            VAL_PKTLEN }, //0xFF},
//  {REG_PKTCTRL1,          VAL_PKTCTRL1}, //0x04},
//  {REG_PKTCTRL0,          VAL_PKTCTRL0}, //0x05},
//  {REG_ADDR,              ID_RADIO}, //0x00},
//  {REG_CHANNR,            CHANNEL}, //0x00},
//  {REG_FSCTRL1,           0x06},
//  {REG_FSCTRL0,           0x00},
//  {REG_FREQ2,             0x20},
//  {REG_FREQ1,             0x34},
//  {REG_FREQ0,             0x62},
//  {REG_MDMCFG4,           0xCA},
//  {REG_MDMCFG3,           0x75},
//  {REG_MDMCFG2,           0x13},
//  {REG_MDMCFG1,           0x22},
//  {REG_MDMCFG0,           0xA9},
//  {REG_DEVIATN,           0x34},
//  {REG_MCSM2,             0x07},
//  {REG_MCSM1,             VAL_MCSM1 }, //0x30},
//  {REG_MCSM0,             0x18},
//  {REG_FOCCFG,            0x16},
//  {REG_BSCFG,             0x6C},
//  {REG_AGCCTRL2,          0x43},
//  {REG_AGCCTRL1,          0x40},
//  {REG_AGCCTRL0,          0x91},
//  {REG_WOREVT1,           0x87},
//  {REG_WOREVT0,           0x6B},
//  {REG_WORCTRL,           0xFB},
//  {REG_FREND1,            0x56},
//  {REG_FREND0,            0x10},
//  {REG_FSCAL3,            0xE9},
//  {REG_FSCAL2,            0x2A},
//  {REG_FSCAL1,            0x00},
//  {REG_FSCAL0,            0x1F},
//  {REG_RCCTRL1,           0x41},
//  {REG_RCCTRL0,           0x00},
//  {REG_FSTEST,            0x59},
//  {REG_PTEST,             0x7F},
//  {REG_AGCTEST,           0x3F},
//  {REG_TEST2,             0x81},
//  {REG_TEST1,             0x2D},
//  {REG_TEST0,             0x09}//,
////  {REG_PARTNUM,           0x00},
////  {REG_VERSION,           0x04},
////  {REG_FREQEST,           0x00},
////  {REG_LQI,               0x00},
////  {REG_RSSI,              0x00},
////  {REG_MARCSTATE,         0x00},
////  {REG_WORTIME1,          0x00},
////  {REG_WORTIME0,          0x00},
////  {REG_PKTSTATUS,         0x00},
////  {REG_VCO_VC_DAC,        0x00},
////  {REG_TXBYTES,           0x00},
////  {REG_RXBYTES,           0x00},
////  {REG_RCCTRL1_STATUS,    0x00},
////  {REG_RCCTRL0_STATUS,    0x00},
//};
//
//#elif defined( BDR38400 )
//static const unsigned char register_values[REG_ROW][REG_COL] = {
//		/*
//		 *
//		 * CONFIGURACION DE SMART RF STUDIO PARA CC1101+CC1190: 38.4Kbaud, Dev:19.8KHz, GSFK, RXBW: 105KHz
//		 *
//		 */
//		{ REG_IOCFG0, VAL_IOCFG0 },
//		{ REG_IOCFG2, /*VAL_IOCFG2*/0x2E },
//		{ REG_FIFOTHR, /*VAL_FIFOTHR*/OPTIMAL_RX_FIFOTHR_VAL },
//		{ REG_PKTCTRL0, VAL_PKTCTRL0 },
//		{ REG_PKTCTRL1, VAL_PKTCTRL1 },
//		{ REG_FSCTRL1, 0x06 },
//#ifdef F868
//		{REG_FREQ2,       0x20},
//		{REG_FREQ1,       0x25},
//		{REG_FREQ0,       0xED},
//#elif defined F869
//		{REG_FREQ2,       0x20},
//		{REG_FREQ1,       0x2F},
//		{REG_FREQ0,       0x68},
//#else
//		{REG_FREQ2,       0x21},
//		{REG_FREQ1,       0xE3},
//		{REG_FREQ0,       0x8E},
//#endif
//
//		{ REG_AGCCTRL2, 0x43},
//		{ REG_AGCCTRL1, 0x40},
//		{ REG_AGCCTRL0, 0x91},
//
//		{ REG_FREND1, 0x56},
//		{ REG_FREND0, 0x10},
//
//		{ REG_MDMCFG4, 0xCA }, //CONFIGURADO PARA 57600
//		{ REG_MDMCFG3, 0x75 },
//		{ REG_MDMCFG2, 0x13 }, //GFSK MODULATION
//		{ REG_MDMCFG1, 0x22 },
//		{ REG_MDMCFG0, 0xF8 },
//
//		{ REG_DEVIATN, 0x34 },
//		{ REG_MCSM0, 0x18 },
//		{ REG_FOCCFG, 0x16 },
//
//		{ REG_WORCTRL, 0xFB },
//		{ REG_FSCAL3, 0xE9 },
//		{ REG_FSCAL2, 0x2A },
//		{ REG_FSCAL1, 0x00 },
//		{ REG_FSCAL0, 0x1F },
//		{ REG_TEST2, 0x81 },
//		{ REG_TEST1, 0x2D },
//		{ REG_TEST0, 0x09 },
//		// Custom setup
//		{ REG_CHANNR, CHANNEL }, //CHANNEL
//		{ REG_ADDR, ID_RADIO }, // Node address
//		{ REG_PKTLEN, VAL_PKTLEN }, // Maximum packet length
//		{ REG_SYNC1, SYNCWORD_H }, //MSB(CC1101_SYNC_WORD) }, // Sync word //TODO revisar
//		{ REG_SYNC0, SYNCWORD_L }, // LSB(CC1101_SYNC_WORD) }, //TODO revisar
//		{ REG_MCSM1, VAL_MCSM1 },
//		{ REG_PATABLE, CC1101_TXPOWER_0dBm } // Default transmit power
//};
//#elif defined BDR19200
//const unsigned char register_values[REG_ROW][REG_COL] = {
//		/*
//		 *
//		 * CONFIGURACION DE SMART RF STUDIO PARA CC1101+CC1190: 38.4Kbaud, Dev:19.8KHz, GSFK, RXBW: 105KHz
//		 *
//		 */
//		{ REG_IOCFG0, VAL_IOCFG0},
//		{ REG_IOCFG1, 0x2E },
//		{ REG_IOCFG2, VAL_IOCFG2},
//		{ REG_FIFOTHR, 0x0F},
//		{ REG_PKTCTRL0, VAL_PKTCTRL0 },
//		{ REG_PKTCTRL1, VAL_PKTCTRL1 },
//
//		{REG_FSCTRL1,     0x06},
//		{REG_FSCTRL0,     0x00},
//#ifdef F868
//		{REG_FREQ2,       0x20},
//		{REG_FREQ1,       0x25},
//		{REG_FREQ0,       0xED},
//#elif defined F869
//		//ANTIGUA FREQ:
//		{REG_FREQ2,       0x20},
//		{REG_FREQ1,       0x2F},
//		{REG_FREQ0,       0x68},
//
//		//OJO: FREQ = 869.4MHz
////		{REG_FREQ2,       0x20},
////		{REG_FREQ1,       0x33},
////		{REG_FREQ0,       0x33},
//#else
//		{REG_FREQ2,       0x21},
//		{REG_FREQ1,       0xE3},
//		{REG_FREQ0,       0x8E},
//#endif
//
//		//Antigua config:
//		{REG_MDMCFG4,     0xC9},
//		{REG_MDMCFG3,     0x75},
//		{REG_MDMCFG2,     0x13},
//		{REG_MDMCFG1,     0x22},
//		{REG_MDMCFG0,     0xF8},
//		{REG_DEVIATN,     0x34},
//
//		//config para 869.4 chann 25KHz
////		{REG_MDMCFG4,     0xf9},
////		{REG_MDMCFG3,     0x75},
////		{REG_MDMCFG2,     0x13},
////		{REG_MDMCFG1,     0x20},
////		{REG_MDMCFG0,     0x00},
////		{REG_DEVIATN,     0x14},
//
//
//		{REG_MCSM0,       0x18}, //Autocalibrate cuando se pasa de IDLE a Rx o Tx
//		{REG_FOCCFG,      0x16},
//		{REG_AGCCTRL2,    0x43},
//		{REG_AGCCTRL1,    0x40},
//		{REG_AGCCTRL0,    0x91},
//		{REG_WORCTRL,     0xFB},
//		{REG_FREND1,      0x56},
//		{REG_FREND0,      0x10},
//		{REG_FSCAL3,      0xE9},
//		{REG_FSCAL2,      0x2A},
//		{REG_FSCAL1,      0x00},
//		{REG_FSCAL0,      0x1F},
//		{REG_TEST2,       0x81},
//		{REG_TEST1,       0x2D},//OPTIMAL_RX_TEST1_VAL},
//		{REG_TEST0,       0x09},
//
//		// Custom setup
//		{ REG_CHANNR, CHANNEL }, //CHANNEL
//		{ REG_ADDR, ID_COORDINADOR },
//		{ REG_PKTLEN, VAL_PKTLEN }, // Maximum packet length
//		{ REG_SYNC1, SYNCWORD_H }, //MSB(CC1101_SYNC_WORD) }, // Sync word //TODO revisar
//		{ REG_SYNC0, SYNCWORD_L }, // LSB(CC1101_SYNC_WORD) }, //TODO revisar
//		{ REG_MCSM1, VAL_MCSM1 },
//		{ REG_PATABLE, CC1101_TXPOWER_0dBm } // Default transmit power
//};
//#elif defined PRUEBA_869_MAX_SENSIVITY_26dBm
//static const unsigned char register_values[REG_ROW][REG_COL] = {
//	{REG_IOCFG2,            0x29},
//	{REG_IOCFG1,            0x2E},
//	{REG_IOCFG0,            VAL_IOCFG0},
//	{REG_FIFOTHR,           0x07},
//	{REG_SYNC1,             0xD3},
//	{REG_SYNC0,             0x91},
//	{REG_PKTLEN,            0xFF},
//	{REG_PKTCTRL1,          VAL_PKTCTRL1},
//	{REG_PKTCTRL0,          VAL_PKTCTRL0},
//	{REG_ADDR,              ID_RADIO},
//	{REG_CHANNR,            CHANNEL},
//	{REG_FSCTRL1,           0x0C},
//	{REG_FSCTRL0,           0x00},
//#ifdef F868
//		{REG_FREQ2,       0x20},
//		{REG_FREQ1,       0x25},
//		{REG_FREQ0,       0xED},
//#elif defined F869
//		{REG_FREQ2,       0x20},
//		{REG_FREQ1,       0x2F},
//		{REG_FREQ0,       0x68},
//#elif defined SEGUN_SMARTRF
//		{REG_FREQ2,       0x20},
//		{REG_FREQ1,       0x33},
//		{REG_FREQ0,       0x4B},
//#else
//		{REG_FREQ2,       0x21},
//		{REG_FREQ1,       0xE3},
//		{REG_FREQ0,       0x8E},
//#endif
//
//
//#ifdef BDRATE_19200
//	{REG_MDMCFG4,           0x29},
//	{REG_MDMCFG3,           0x79},
//#elif defined BDRATE_9600
//	{REG_MDMCFG4,           0x28},
//	{REG_MDMCFG3,           0x75},
//#endif
//
//#ifdef CONFIG_RADIO_KIT_TEXAS
//	{REG_MDMCFG2,     0x13},
//	{REG_MDMCFG1,     0x22},
//	{REG_MDMCFG0,     0xF8},
//	{REG_DEVIATN,     0x34},
//	{REG_MCSM0,       0x18}, //Autocalibrate cuando se pasa de IDLE a Rx o Tx
//	{REG_FOCCFG,      0x16},
//	{REG_AGCCTRL2,    0x43},
//	{REG_AGCCTRL1,    0x40},
//	{REG_AGCCTRL0,    0x91},
//	{REG_FREND1,      0x56},
//	{REG_FREND0,      0x10},
//	{REG_FSCAL3,      0xE9},
//	{REG_FSCAL2,      0x2A},
//	{REG_FSCAL1,      0x00},
//	{REG_FSCAL0,      0x1F},
//#elif defined SEGUN_SMARTRF
//	{REG_MDMCFG2,           0x13},
//	{REG_MDMCFG1,           0x20},
//	{REG_MDMCFG0,           0x00},
//	{REG_DEVIATN,           0x62},
//	{REG_MCSM2,             0x07},
//	{REG_MCSM1,             0x30},
//	{REG_MCSM0,             0x18},
//	{REG_FOCCFG,            0x1D},
//	{REG_AGCCTRL2,          0xC7},
//	{REG_AGCCTRL1,          0x00},
//	{REG_AGCCTRL0,          0xB0},
//	{REG_FREND1,            0xB6},
//	{REG_FREND0,            0x10},
//	{REG_FSCAL3,            0xEA},
//	{REG_FSCAL2,            0x2A},
//	{REG_FSCAL1,            0x00},
//	{REG_FSCAL0,            0x1F},
//#endif
//
//
//
//	{REG_BSCFG,             0x1C},
//
////	{REG_WOREVT1,           0x87},
////	{REG_WOREVT0,           0x6B},
//	{REG_WORCTRL,           0xFB},
//
//
//	{REG_RCCTRL1,           0x41},
//	{REG_RCCTRL0,           0x00},
//	{REG_FSTEST,            0x59},
//	{REG_PTEST,             0x7F},
//	{REG_AGCTEST,           0x3F},
//	{REG_TEST2,             0x88},
//	{REG_TEST1,             0x31},
//	{REG_TEST0,             0x09}
//};
//#elif defined LAST_TEST
//static const unsigned char register_values[REG_ROW][REG_COL] =
//{
//	{REG_IOCFG0,      VAL_IOCFG0},
//	{REG_PKTCTRL1,    VAL_PKTCTRL1},
//	{REG_PKTCTRL0,    VAL_PKTCTRL0},
//	{REG_ADDR,        ID_RADIO},
//	{REG_CHANNR,      CHANNEL},
//
//	{REG_IOCFG2,            0x29},
//	{REG_IOCFG1,            0x2E},
//	//{REG_IOCFG0,            0x06},
//	{REG_FIFOTHR,           0xC7},
//	{REG_SYNC1,             0xD3},
//	{REG_SYNC0,             0x91},
//	{REG_PKTLEN,            0xFF},
//	//{REG_PKTCTRL1,          0x04},
//	//{REG_PKTCTRL0,          0x05},
//	//{REG_ADDR,              0x00},
//	//{REG_CHANNR,            0x00},
//	{REG_FSCTRL1,           0x06},
//	{REG_FSCTRL0,           0x00},
//	{REG_FREQ2,             0x20},
//	{REG_FREQ1,             0x2F},
//	{REG_FREQ0,             0x68},
//	{REG_MDMCFG4,           0xC7},
//	{REG_MDMCFG3,           0x7D},
//	{REG_MDMCFG2,           0x13},
//	{REG_MDMCFG1,           0x22},
//	{REG_MDMCFG0,           0xF8},
//	{REG_DEVIATN,           0x37},
//	{REG_MCSM2,             0x07},
//	{REG_MCSM1,             0x30},
//	{REG_MCSM0,             0x18},
//	{REG_FOCCFG,            0x16},
//	{REG_BSCFG,             0x6C},
//	{REG_AGCCTRL2,          0x43},
//	{REG_AGCCTRL1,          0x40},
//	{REG_AGCCTRL0,          0x91},
//	{REG_WOREVT1,           0x87},
//	{REG_WOREVT0,           0x6B},
//	{REG_WORCTRL,           0xFB},
//	{REG_FREND1,            0x56},
//	{REG_FREND0,            0x10},
//	{REG_FSCAL3,            0xE9},
//	{REG_FSCAL2,            0x2A},
//	{REG_FSCAL1,            0x00},
//	{REG_FSCAL0,            0x1F},
//	{REG_RCCTRL1,           0x41},
//	{REG_RCCTRL0,           0x00},
//	{REG_FSTEST,            0x59},
//	{REG_PTEST,             0x7F},
//	{REG_AGCTEST,           0x3F},
//	{REG_TEST2,             0x81},
//	{REG_TEST1,             0x2D},
//	{REG_TEST0,             0x09},
//	{REG_PARTNUM,           0x00},
//	{REG_VERSION,           0x04},
//	{REG_FREQEST,           0x00},
//	{REG_LQI,               0x00},
//	{REG_RSSI,              0x00},
//	{REG_MARCSTATE,         0x00},
//	{REG_WORTIME1,          0x00},
//	{REG_WORTIME0,          0x00},
//	{REG_PKTSTATUS,         0x00},
//	{REG_VCO_VC_DAC,        0x00},
//	{REG_TXBYTES,           0x00},
//	{REG_RXBYTES,           0x00},
////	{REG_RCCTRL1_STATUS,    0x00},
////	{REG_RCCTRL0_STATUS,    0x00},
//};
//#endif


extern unsigned char spi_write_single(unsigned char );
extern void Usecs_TimerA(unsigned long);
















//**********************************************
// SimpleMesh software
//**********************************************
//#include "precompilador.h"


//#define ADDR_CONFIGURADOR		0xFEu
//#define SUBADDR_CONFIGURADOR	0xFEu //Ser la misma para la id fsica como para la virtual
//#define BROADCAST				0x00
//#define ADDR_CONFI_2BYTES		0xFEFEu







//Posiciones de bytes en tramas RECIBIDAS:

//Posiciones de bytes de tramas ENVIADAS:

//MXIMO TAMAO DE FIFO DE TRANSMISIN DE LA RADIO:


//BYTES DE CABECERA:

//NMERO TOTAL DE BYTES DE CABECERA:

//NMERO MXIMO DE BYTES PARA DATOS PUROS

//TAMAO MXIMO DE PAQUETE RADIO:


//TIPOS DE TRAMA:




//POSICION DE LOS BYTES EN LA INFO DEL NODO [TABLA_NODOS]



/*
 * structs.h
 *
 *  Created on: 02/06/2014
 *      Author: Luis J. Lpez
 */


//TIPO DE MOTA:
enum{
    DM124      	= 0,
    TELOSBDM124	= 1,
    IAQM       	= 2,
    SP1        	= 3,
    DM108_		= 4,
    HELIOS_		= 5
};

typedef enum {
	SIN_ACTIVIDAD,
	RADIO_TX,
	RADIO_TX_BROADCAST,
	RADIO_RX,
	RS485_RX,
	RS485_TX,
	SYSTEM_CONFIGURATION,
	VALORES_DE_FABRICA
}Maquina_Estados;

typedef union
{
	unsigned char buf_var[2];
	unsigned int int_var;
}Int_2_Char;

typedef struct
{
	unsigned char Group_ID;							//Nmero de grupo al que pertenece la radio.
	unsigned char Id_MODBUS;						//Nmero de identificacin de MODBUS

	unsigned char Uart_Configuracion;				//Configuracin de la uart para el bus RS485
	unsigned char Canal_Radio;						//Canal fsico de Radio
	unsigned char Tipo_Mota;						//Tipo de mota: DM108 o HELIOS
	Int_2_Char Radio_Id;							//Nmero de Identificacin de la RADIO: La fsica y la virtual
	unsigned char fw_version;						//Versin del firmware

	//unsigned char Config_Guardada_Anteriormente;	//Variable que indica si se ha guardado anteriormente en memoria la configuracin
	unsigned char Radio_Power;						//Potencia de transmisin de la radio
	unsigned char Tipo_Comunicacion_con_Balasto;	//Tipo de comunicacin con la luminaria: DALI o DIMMER
	unsigned char Rol_Nodo;
	unsigned char ACK_Enable; //ACK activado?
	unsigned char Reintentos_ACK;  //Numero de veces que se intentara la comunicacin inalmbrica
	unsigned char AES_Enable;
	Int_2_Char Timeout_ACK; //Timeout para dar por perdida una trama

	unsigned char Routing_Retries;
	unsigned long Serial_Num_DM108;

	unsigned char Estado_Real_Salida;
	unsigned char Modo_Salida_Permanente;
	unsigned char Modo_Pulso_Unico;
	volatile unsigned char Modo_PWM_Salida;	//Salida PWM activada o no

	//volatile unsigned char Pulso_Salida;
	unsigned int Duracion_Pulso_Salida; //en milisegundos
	unsigned int Duracion_PWM_ON; //en milisegundos
	unsigned int Duracion_PWM_OFF; //en milisegundos

	unsigned int Segundos_Sin_Actividad; //35 minutos por defecto
	unsigned long Microsegundos_Delay_Transmision;


	//unsigned char Modo_Actual_Pulso; //Para el WMConfigTool

	unsigned char numero_ACKs_A_Enviar;

	//Para el tanteo de pulsos:
	unsigned char Flanco_Del_Pulso;


	Int_2_Char Frecuencia_Base;




}Equipo_Config;




extern Equipo_Config Mota_Conf;
extern unsigned char buf_aux_transmision[128];
extern unsigned char flash_buffer_Read[0x0200u];
extern unsigned char Num_Serie_Ya_Grabado;
extern volatile unsigned char Reset_Mandatory;
extern unsigned long Segundos_a_milisegundos;
extern volatile unsigned long Tiempo_Para_Reseteo_vs_Inactividad;

extern void Read_NBytes_From_Flash(unsigned long , unsigned int );

/*
 * Byte UART_Configuracion:
 *	bit 7 	-	0	-	bit 6	-	0	-	2400 bps
 *								-	1 	-	4800 bps
 * 			-	1	-	bit 6	-	0	-	9600 bps
 *								-	1	-	19200 bps
 *	bit 5	-	0	-	NO PARITY
 *			-	1	-	bit 4	-	0	-	PARIDAD IMPAR
 *								-	1	-	PARIDAD PAR
 *	bit 3	-	0	-	StopBits = 1
 *			-	1	-	StopBits = 2
 *	bit 2	-	0	-	Nbits = 7
 *			-	1	-	Nbits = 8
 */

void Configuracion_Por_Defecto_MOTA(void)
{
	//Valores por defecto:
	Mota_Conf.Group_ID = 0;
	Mota_Conf.Id_MODBUS = 0x01;
	Mota_Conf.Uart_Configuracion = 0xC4u; //11000100	19200 8 N 1
	Mota_Conf.Canal_Radio = 0x00;
	Mota_Conf.Radio_Power = 0x03u;//CC1101_CC1190_TXPOWER_26dBm;//CC1101_CC1190_TXPOWER_minus2dBm;
	Mota_Conf.AES_Enable = 1u;
	Mota_Conf.ACK_Enable = 1u;
	Mota_Conf.Reintentos_ACK = 3u;
	Mota_Conf.Timeout_ACK.int_var = 50u;
	Mota_Conf.Routing_Retries = 3u;

	Mota_Conf.numero_ACKs_A_Enviar = 2u;

}

/*static */void Carga_Configuracion_MOTA(void)
{
	extern void Wait_Usecs_TimerA0(unsigned long );
	extern void Change_Radio_Channel(unsigned char );
	//extern void Read_NBytes_From_Flash(unsigned long , unsigned int );

	extern void Carga_Config_de_Seg_C(void);
	unsigned char Configuracion_Guardada;

	extern unsigned int Get_Radio_ID(unsigned char );


/////////////////////////////////////////////////////////////////////////////////////////////////
	//INICIO:
	(PCOUT_H) &= ~(0x10u | 0x08u);
	Wait_Usecs_TimerA0(200000);
    (PCOUT_H) |= 0x10u | 0x08u;
////////////////////////////////////////////////////////////////////////////////////////////////



    //En la primera posicin del segmento C est el byte que indica si se ha guardado la configuracin:
	Read_NBytes_From_Flash(0x1880u, 1);
	Configuracion_Guardada = flash_buffer_Read[0];

    Reset_Mandatory = 0u;

    Mota_Conf.fw_version = 0x0022u;
    Mota_Conf.Tipo_Mota = DM108_;


    //Se leen los bytes de configuracin MS UNO que es el que indica si hay configuracin guardada:
	/*pbuf = */Read_NBytes_From_Flash(0x1980u, (19u + 1u) + ((((((((((19u + 1u) + 1) + 4) + 1) + 1) + 1) + 1) + 1) + 1) + 1 - (19u + 1u))); //cargamos tambin el nmero de serie y el enable tabla y el time rs485
	WDTCTL = (0x5A00) + (0x0080);

	if(flash_buffer_Read[(((19u + 1u) + 1) + 4)] != 0xFF)
	{
		Num_Serie_Ya_Grabado = 1u;
		flash_buffer_Read[(((19u + 1u) + 1) + 4)] = Num_Serie_Ya_Grabado;
	}
	else
	{
		Num_Serie_Ya_Grabado = 0u;
		flash_buffer_Read[(((19u + 1u) + 1) + 4)] = 0xFF;
	}

	Mota_Conf.Serial_Num_DM108 = ((unsigned long)flash_buffer_Read[((19u + 1u) + 1)])<<24;
	Mota_Conf.Serial_Num_DM108 |= ((unsigned long)flash_buffer_Read[((19u + 1u) + 1) + 1])<<16;
	Mota_Conf.Serial_Num_DM108 |= ((unsigned long)flash_buffer_Read[((19u + 1u) + 1) + 2])<<8;
	Mota_Conf.Serial_Num_DM108 |= ((unsigned long)flash_buffer_Read[((19u + 1u) + 1) + 3]);




	/*****/
	//FRECUENCIA BASE:
	Mota_Conf.Frecuencia_Base.buf_var[1] = flash_buffer_Read[(((((((((19u + 1u) + 1) + 4) + 1) + 1) + 1) + 1) + 1) + 1)];
	Mota_Conf.Frecuencia_Base.buf_var[0] = flash_buffer_Read[((((((((19u + 1u) + 1) + 4) + 1) + 1) + 1) + 1) + 1)];

	if(Mota_Conf.Frecuencia_Base.int_var != 868u && Mota_Conf.Frecuencia_Base.int_var != 865u)
	{
		Mota_Conf.Frecuencia_Base.int_var = 868u; //Por defecto siempre 868MHz
	}

	Mota_Conf.Segundos_Sin_Actividad = (unsigned int)(flash_buffer_Read[((((19u + 1u) + 1) + 4) + 1)]) << 8;
	Mota_Conf.Segundos_Sin_Actividad += flash_buffer_Read[(((((19u + 1u) + 1) + 4) + 1) + 1)];

	if(Mota_Conf.Segundos_Sin_Actividad < 10 || Mota_Conf.Segundos_Sin_Actividad == 0xFFFF )
	{
		Mota_Conf.Segundos_Sin_Actividad = 600; //10 minutos sin ACTIVIDAD por DEFECTO
		Segundos_a_milisegundos = 300000ul;
	}
	else
	{
		Segundos_a_milisegundos = 500ul * Mota_Conf.Segundos_Sin_Actividad; //Los minutos en bloques de 2ms
	}
	Tiempo_Para_Reseteo_vs_Inactividad = Segundos_a_milisegundos;

	Mota_Conf.Microsegundos_Delay_Transmision = (unsigned int)(flash_buffer_Read[((((((19u + 1u) + 1) + 4) + 1) + 1) + 1)]) << 8;
	Mota_Conf.Microsegundos_Delay_Transmision += flash_buffer_Read[(((((((19u + 1u) + 1) + 4) + 1) + 1) + 1) + 1)];
	if(Mota_Conf.Microsegundos_Delay_Transmision > 1000){
		Mota_Conf.Microsegundos_Delay_Transmision = 0;}
	else{
		Mota_Conf.Microsegundos_Delay_Transmision *= 1000ul;}


	if(Configuracion_Guardada == 1u && flash_buffer_Read[2u] > 0 && flash_buffer_Read[2u] < 248 && flash_buffer_Read[1u] < 10) //si se ha salvado anteriormente la configuracin y no est corrupta:
	{
		Mota_Conf.Group_ID = flash_buffer_Read[0u];
		Mota_Conf.Canal_Radio = flash_buffer_Read[1u];// = punt->Canal_Radio;
		Mota_Conf.Id_MODBUS = flash_buffer_Read[2u];// = punt->Id_MODBUS;
		Mota_Conf.Rol_Nodo = flash_buffer_Read[3u];
		Mota_Conf.Routing_Retries = flash_buffer_Read[4u];
		if(Mota_Conf.Routing_Retries < 1)
		{
			Mota_Conf.Routing_Retries = 3;
			flash_buffer_Read[4u] = 3;
		}
		Mota_Conf.Uart_Configuracion = flash_buffer_Read[5u];// = punt->Uart_Configuracion;

		Mota_Conf.Radio_Id.buf_var[1u] = flash_buffer_Read[6u];// = punt->Radio_Id.id_radio_local;
		if(Mota_Conf.Radio_Id.buf_var[1u] < 1 || Mota_Conf.Radio_Id.buf_var[1u] > 0xFE)
		{
			Mota_Conf.Radio_Id.buf_var[1u] = 0xFE;
			flash_buffer_Read[6u] = 0xFE;
		}
		Mota_Conf.Radio_Id.buf_var[0u] = flash_buffer_Read[7u];// = punt->Radio_Id.subid_radio_local;

		Mota_Conf.Radio_Power = flash_buffer_Read[10u];
		if(Mota_Conf.Radio_Power == 0x86u) //evitamos la saturacin
			Mota_Conf.Radio_Power = 0x50u;

		Mota_Conf.Reintentos_ACK = flash_buffer_Read[13u];
		Mota_Conf.ACK_Enable = flash_buffer_Read[8u];
		Mota_Conf.AES_Enable = flash_buffer_Read[9u];
		Mota_Conf.Timeout_ACK.buf_var[1] = flash_buffer_Read[16u];
		Mota_Conf.Timeout_ACK.buf_var[0] = flash_buffer_Read[17u];

		if(Mota_Conf.Timeout_ACK.int_var < 25)
		{
			Mota_Conf.Timeout_ACK.int_var = 25;
			flash_buffer_Read[16u] = 0;
			flash_buffer_Read[17u] = 25;
		}

		Mota_Conf.numero_ACKs_A_Enviar = flash_buffer_Read[19u];

		if(Mota_Conf.numero_ACKs_A_Enviar > 6 || Mota_Conf.numero_ACKs_A_Enviar < 1)
			Mota_Conf.numero_ACKs_A_Enviar = 2;

		if (Mota_Conf.Rol_Nodo == 0 && Mota_Conf.Radio_Id.int_var <= 257)
		{
			Mota_Conf.Radio_Id.int_var = Get_Radio_ID(1);
		}
		else if(Mota_Conf.Rol_Nodo == 1 && Mota_Conf.Radio_Id.int_var != 257)
		{
			Mota_Conf.Radio_Id.int_var = 0x0101;
		}

	}
	else if(Configuracion_Guardada == 1u)
	{
		//Parece corrupta la config en segmento A
		Carga_Config_de_Seg_C();
	}
	else //Si NO ha sido anteriormente guardada, cargamos la de por defecto
	{

		//Por defecto siempre se tiene rol de endpoint:
		Mota_Conf.Rol_Nodo = 0;


		if(flash_buffer_Read[6u] == 0xFF || flash_buffer_Read[6u] == 0x00 || (flash_buffer_Read[6u] == 0x01 && flash_buffer_Read[7u] == 0x01))
		{
			//OW_LASERED_ROM(DS2411);
			//Leer_ID();
			Mota_Conf.Radio_Id.int_var = Get_Radio_ID(1);
		}
		else
		{
			Mota_Conf.Radio_Id.buf_var[1u] = flash_buffer_Read[6u];
			Mota_Conf.Radio_Id.buf_var[0u] = flash_buffer_Read[7u];
		}




		Configuracion_Por_Defecto_MOTA();

	}

	/*
	 * Si es endpoint, NO puede tener el radio id de un coordinador:
	 */
	if(Mota_Conf.Rol_Nodo == 0 && Mota_Conf.Radio_Id.int_var == 257)
	{
		Mota_Conf.Radio_Id.int_var = Get_Radio_ID(1);
	}

	WDTCTL = (0x5A00) + (0x0080);

}



void Guardado_Redundante_Config_en_Seg_C(void)
{
	unsigned char i;

	extern void Write_Nbytes_in_Segment (unsigned char *, unsigned long , unsigned int );

	i = 0;

	buf_aux_transmision[i++] = 1u; //Configuracin guardada.
	buf_aux_transmision[i++] = Mota_Conf.Group_ID;
	buf_aux_transmision[i++] = Mota_Conf.Canal_Radio;
	buf_aux_transmision[i++] = Mota_Conf.Id_MODBUS;
	buf_aux_transmision[i++] = Mota_Conf.Rol_Nodo;
	buf_aux_transmision[i++] = Mota_Conf.Routing_Retries;
	buf_aux_transmision[i++] = Mota_Conf.Uart_Configuracion;
	buf_aux_transmision[i++] = Mota_Conf.Radio_Id.buf_var[1];
	buf_aux_transmision[i++] = Mota_Conf.Radio_Id.buf_var[0];
	buf_aux_transmision[i++] = Mota_Conf.ACK_Enable;
	buf_aux_transmision[i++] = Mota_Conf.AES_Enable;
	buf_aux_transmision[i++] = Mota_Conf.Radio_Power;
	buf_aux_transmision[i++] = 0; //tipo de mota. da igual aqu porque no se graba en memoria
	buf_aux_transmision[i++] = 0; //versin FW. da igual aqu porque no se graba en memoria
	buf_aux_transmision[i++] = Mota_Conf.Reintentos_ACK;
	buf_aux_transmision[i++] = 0; //reservado. da igual aqu porque no se graba en memoria
	buf_aux_transmision[i++] = 0; //reservado. da igual aqu porque no se graba en memoria
	buf_aux_transmision[i++] = Mota_Conf.Timeout_ACK.buf_var[1];
	buf_aux_transmision[i++] = Mota_Conf.Timeout_ACK.buf_var[0];
	buf_aux_transmision[i++] = 0; //reservado. da igual aqu porque no se graba en memoria
	buf_aux_transmision[i++] = Mota_Conf.numero_ACKs_A_Enviar;

	//Ahora guardamos en el segmento C
	Write_Nbytes_in_Segment (buf_aux_transmision, 0x1880u, i);

}

void Carga_Config_de_Seg_C(void)
{
	unsigned char i;
	i = 0;

	Read_NBytes_From_Flash(0x1880u, 21);

	i++; //Pasamos del byte de guardado
	Mota_Conf.Group_ID = flash_buffer_Read[i++];
	Mota_Conf.Canal_Radio = flash_buffer_Read[i++];
	Mota_Conf.Id_MODBUS = flash_buffer_Read[i++];
	Mota_Conf.Rol_Nodo = flash_buffer_Read[i++];
	Mota_Conf.Routing_Retries = flash_buffer_Read[i++];
	Mota_Conf.Uart_Configuracion = flash_buffer_Read[i++];
	Mota_Conf.Radio_Id.buf_var[1] = flash_buffer_Read[i++];
	Mota_Conf.Radio_Id.buf_var[0] = flash_buffer_Read[i++];
	Mota_Conf.ACK_Enable = flash_buffer_Read[i++];
	Mota_Conf.AES_Enable = flash_buffer_Read[i++];
	Mota_Conf.Radio_Power = flash_buffer_Read[i++];
	i++;
	i++;
	Mota_Conf.Reintentos_ACK = flash_buffer_Read[i++];
	i++;
	i++;
	Mota_Conf.Timeout_ACK.buf_var[1] = flash_buffer_Read[i++];
	Mota_Conf.Timeout_ACK.buf_var[0] = flash_buffer_Read[i++];
	i++;
	Mota_Conf.numero_ACKs_A_Enviar = flash_buffer_Read[i++];
	if(Mota_Conf.numero_ACKs_A_Enviar > 6 || Mota_Conf.numero_ACKs_A_Enviar < 1)
			Mota_Conf.numero_ACKs_A_Enviar = 2;

}



/*
 * //POSICIONES DE LOS BYTES DE CONFIGURACIN:
#define POS_BYTE_GROUP_ID				0u		//Memoria Fsica = 0x1980 	[INFORMATION_SEGMENT_A_START_ADDRESS]
#define POS_BYTE_RADIO_CHANN			1u       //Memoria Fsica = 0x1981
#define POS_BYTE_MODBUS_ID				2u       //Memoria Fsica = 0x1982
#define POS_BYTE_ROL_NODO				3u       //Memoria Fsica = 0x1983
//OJO//                                         //Memoria Fsica = 0x1984
#define POS_BYTE_ROUTING_RETRIES		4u       //Memoria Fsica = 0x1985
//////                                          //Memoria Fsica = 0x1986
#define POS_BYTE_UART_CONF				5u       //Memoria Fsica = 0x1987
#define POS_BYTE_ID_RADIO_H				6u       //Memoria Fsica = 0x1988
#define POS_BYTE_ID_RADIO_L				7u      //Memoria Fsica = 0x1989
#define POS_BYTE_ACK_ENABLE				8u       //Memoria Fsica = 0x198A
#define POS_BYTE_AES_ENABLE				9u       //Memoria Fsica = 0x198B
#define POS_BYTE_RADIO_TX_PWR			10u      //Memoria Fsica = 0x198C
#define POS_BYTE_TIPO_MOTA				11u     //Memoria Fsica = 0x198D
#define POS_BYTE_FW_VERSION				12u      //Memoria Fsica = 0x198E
#define POS_BYTE_REINTENTOS_ACK			13u      //Memoria Fsica = 0x198F
//#define POS_BYTE_TIMEOUT_MODBUS_H		14      //Memoria Fsica = 0x1990
//#define POS_BYTE_TIMEOUT_MODBUS_L		15      //Memoria Fsica = 0x1992
#define POS_BYTE_TIMEOUT_ACK_H			16u      //Memoria Fsica = 0x1992
#define POS_BYTE_TIMEOUT_ACK_L			17u      //Memoria Fsica = 0x1993

#define POS_BYTE_NUM_ACKS_A_ENVIAR_H	18u      //Memoria Fsica = 0x1994
#define POS_BYTE_NUM_ACKS_A_ENVIAR_L	19u      //Memoria Fsica = 0x1995

#define CONFIG_REAL_NUM_BYTES			(POS_BYTE_TIMEOUT_ACK_L + 1u) //Los numeros de acks a enviar no se tienen en cuenta...

//#define POS_BYTE_CONF_GUARDADA			(POS_BYTE_NUM_ACKS_A_ENVIAR_L + 1u)		//Memoria Fsica = 0x1996
#define POS_BYTE_RESERVADO_I			(POS_BYTE_NUM_ACKS_A_ENVIAR_L + 1u)		//Memoria Fsica = 0x1996

#define NUM_BYTES_CONFIGURACION			POS_BYTE_RESERVADO_I//(POS_BYTE_CONF_GUARDADA + 1)
#define NUM_REGS_CONFIGURACION			(NUM_BYTES_CONFIGURACION/2u)

#define MEM_ADDRESS_SERIAL_NUM_DM108			(INFORMATION_SEGMENT_A_START_ADDRESS + POS_BYTE_RESERVADO_I + 1)
#define POS_PRIMER_BYTE_SERIAL_NUM				(POS_BYTE_RESERVADO_I + 1) //19
#define POS_NUM_SERIE_YA_GUARDADO				(POS_PRIMER_BYTE_SERIAL_NUM + 4) //23

#define POS_SEGUNDOS_SIN_ACTIVIDAD				(POS_NUM_SERIE_YA_GUARDADO + 1)//(POS_MODO_PULSO_ACTUAL + 1)
#define MEM_ADDRESS_SEG_SIN_ACT					(INFORMATION_SEGMENT_A_START_ADDRESS + POS_SEGUNDOS_SIN_ACTIVIDAD)
#define POS_DELAY_TRANSMISION					(POS_SEGUNDOS_SIN_ACTIVIDAD + 2)
#define MEM_ADDRESS_DELAY_TRANS					(INFORMATION_SEGMENT_A_START_ADDRESS + POS_DELAY_TRANSMISION)


//AL UTILIZAR UNA UNION, PRIMERO GUARDO EL BYTE MENOS SIGNIFICATIVO!!!!
#define POS_FRECUENCIA_BASE_L					(POS_DELAY_TRANSMISION + 2)
#define MEM_ADDRESS_FRECUENCIA_BASE_L			(INFORMATION_SEGMENT_A_START_ADDRESS + POS_FRECUENCIA_BASE_L)
#define POS_FRECUENCIA_BASE_H					(POS_FRECUENCIA_BASE_L + 1)
#define MEM_ADDRESS_FRECUENCIA_BASE_H			(INFORMATION_SEGMENT_A_START_ADDRESS + POS_FRECUENCIA_BASE_H)


#define NUM_EXTRA_BYTES							(POS_FRECUENCIA_BASE_H + 1 - NUM_BYTES_CONFIGURACION)
 *
 */


void Guardado_Configuracion_Principal(void)
{
	//unsigned char i;

	extern void Write_Nbytes_in_Segment (unsigned char *, unsigned long , unsigned int );
	extern unsigned char buf_aux_transmision[128];
	extern Equipo_Config Mota_Conf;

	//buf_aux_transmision[i++] = TRUE; //Configuracin guardada.
	buf_aux_transmision[0u] = Mota_Conf.Group_ID;
	buf_aux_transmision[1u] = Mota_Conf.Canal_Radio;
	buf_aux_transmision[2u] = Mota_Conf.Id_MODBUS;
	buf_aux_transmision[3u] = Mota_Conf.Rol_Nodo;
	buf_aux_transmision[4u] = Mota_Conf.Routing_Retries;
	buf_aux_transmision[5u] = Mota_Conf.Uart_Configuracion;
	buf_aux_transmision[6u] = Mota_Conf.Radio_Id.buf_var[1];
	buf_aux_transmision[7u] = Mota_Conf.Radio_Id.buf_var[0];
	buf_aux_transmision[8u] = Mota_Conf.ACK_Enable;
	buf_aux_transmision[9u] = Mota_Conf.AES_Enable;
	buf_aux_transmision[10u] = Mota_Conf.Radio_Power;
	//buf_aux_transmision[i++] = 0; //tipo de mota. da igual aqu porque no se graba en memoria
	//buf_aux_transmision[i++] = 0; //versin FW. da igual aqu porque no se graba en memoria
	buf_aux_transmision[13u] = Mota_Conf.Reintentos_ACK;
	//buf_aux_transmision[i++] = 0; //reservado. da igual aqu porque no se graba en memoria
	//buf_aux_transmision[i++] = 0; //reservado. da igual aqu porque no se graba en memoria
	buf_aux_transmision[16u] = Mota_Conf.Timeout_ACK.buf_var[1];
	buf_aux_transmision[17u] = Mota_Conf.Timeout_ACK.buf_var[0];
	buf_aux_transmision[18u] = 0; //reservado. da igual aqu porque no se graba en memoria
	buf_aux_transmision[19u] = Mota_Conf.numero_ACKs_A_Enviar;


/*
	buf_aux_transmision[POS_FRECUENCIA_BASE_H] = Mota_Conf.Frecuencia_Base.buf_var[BYTE_ALTO_UNION];
	buf_aux_transmision[POS_FRECUENCIA_BASE_L] = Mota_Conf.Frecuencia_Base.buf_var[BYTE_BAJO_UNION];

	buf_aux_transmision[POS_SEGUNDOS_SIN_ACTIVIDAD_H] = Mota_Conf.Segundos_Sin_Actividad >> 8;
	buf_aux_transmision[POS_SEGUNDOS_SIN_ACTIVIDAD_L] = Mota_Conf.Segundos_Sin_Actividad;

	buf_aux_transmision[POS_DELAY_TRANSMISION_H] = Mota_Conf.Microsegundos_Delay_Transmision >> 8;
	buf_aux_transmision[POS_DELAY_TRANSMISION_L] = Mota_Conf.Microsegundos_Delay_Transmision;

	buf_aux_transmision[POS_NUM_SERIE_YA_GUARDADO] = TRUE;

	buf_aux_transmision[POS_PRIMER_BYTE_SERIAL_NUM] = Mota_Conf.Serial_Num_DM108 >> 24;
	buf_aux_transmision[POS_PRIMER_BYTE_SERIAL_NUM + 1] = Mota_Conf.Serial_Num_DM108 >> 16;
	buf_aux_transmision[POS_PRIMER_BYTE_SERIAL_NUM + 2] = Mota_Conf.Serial_Num_DM108 >> 8;
	buf_aux_transmision[POS_PRIMER_BYTE_SERIAL_NUM + 3] = Mota_Conf.Serial_Num_DM108;
*/
	//Ahora guardamos en el segmento C
	Write_Nbytes_in_Segment (buf_aux_transmision, 0x1980u, (19u + 1u));// + NUM_EXTRA_BYTES);


}























